// jiserver.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "jiserver.h"
#include "kanji.h"


#define AUTHOR_STRING					_T("{D")
#define VERSION_STRING					_T("Ver 1.3")

HINSTANCE g_hInstance;
HWND g_hWnd;
HFONT g_hFont;
TCHAR g_AppPath[MAX_PATH];
TCHAR g_AppDir[MAX_PATH];
UINT g_HotKeyCode;
TCHAR g_KeyCodeTable[256];
BOOL g_bKeyLock;
BOOL g_bEnableIME;
BOOL g_bConvert;
DWORD g_InputMode;
TCHAR g_Buffer[2][256];
DWORD g_Position;
DWORD g_CandidatePosition;
DWORD g_CombinationPosition;
KANJI_BUNSETSU g_Result[KANJI_MAX_WORD];
KANJI_BUNSETSU_CANDIDATE g_Candidate[256];
DWORD g_dwCandidate;
TCHAR g_Kana[3][256];
KANJI_DICTIONARY* g_pConvert[KANJI_MAX_WORD];
DWORD g_dwConvert;
KANJI_DICTIONARY* g_pLearning[KANJI_MAX_WORD];
DWORD g_dwLearning;
BOOL g_bKanaCommand;
BOOL g_bKanaCommandMenu;
KANJI_DICTIONARY g_KanaCommandDictionary[64];
DWORD g_dwKanaCommandDictionary;
BOOL g_bComplement;
TCHAR g_History[64][256];
DWORD g_HistoryCount;

void InsertChar(TCHAR* pString, TCHAR Char, DWORD Position)
{
	TCHAR* p1;
	TCHAR* p2;
	TCHAR c1;
	TCHAR c2;
	p1 = pString;
	p2 = p1 + Position;
	while(*p1 != _T('\0') && p1 < p2)
	{
		p1++;
	}
	if(*p1 != _T('\0'))
	{
		c1 = *p1;
		*p1 = Char;
		p1++;
		while(*p1 != _T('\0'))
		{
			c2 = *p1;
			*p1 = c1;
			p1++;
			c1 = c2;
		}
		*p1 = c1;
		p1++;
		*p1 = _T('\0');
	}
	else
	{
		*p1 = Char;
		p1++;
		*p1 = _T('\0');
	}
}

void RemoveChar(TCHAR* pString, DWORD Position)
{
	TCHAR* p1;
	TCHAR* p2;
	p1 = pString;
	p2 = p1 + Position;
	while(*p1 != _T('\0') && p1 < p2)
	{
		p1++;
	}
	while(p1[0] != _T('\0'))
	{
		p1[0] = p1[1];
		p1++;
	}
}

class CFile : public CFileAlternative
{
public:
	DWORD m_dwSize;
	BYTE* m_pBuf;
	DWORD m_dwPointer;
	CFile()
	{
		CFileAlternative::CFileAlternative();
		m_dwSize = 0;
		m_pBuf = NULL;
		m_dwPointer = 0;
	}
	~CFile()
	{
		if(m_hFile != INVALID_HANDLE_VALUE && m_bCloseOnDelete)
			Close();
		if(m_pBuf)
			delete []m_pBuf;
	}
	BOOL Open(LPCTSTR lpszFileName, UINT nOpenFlags, void* pError)
	{
		Close();
		if(m_pBuf)
			delete []m_pBuf;
		m_dwSize = 65536;
		m_pBuf = new BYTE[m_dwSize];
		m_dwPointer = 0;
		return CFileAlternative::Open(lpszFileName, nOpenFlags, pError);
	}
    void Write(const void* lpBuf, UINT nCount)
	{
		DWORD dw;
		BYTE* pBuf;
		DWORD i;
		DWORD j;
		if(m_pBuf)
		{
			pBuf = (BYTE*)lpBuf;
			i = nCount;
			while(i > 0)
			{
				j = min(m_dwSize - m_dwPointer, i);
				memcpy(m_pBuf + m_dwPointer, pBuf, j);
				pBuf += j;
				i -= j;
				m_dwPointer += j;
				if(m_dwPointer >= m_dwSize)
				{
					WriteFile(m_hFile, m_pBuf, m_dwPointer, &dw, NULL);
					m_dwPointer = 0;
				}
			}
		}
		else
			WriteFile(m_hFile, lpBuf, nCount, &dw, NULL);
	}
	void Flush()
	{
		DWORD dw;
		if(m_pBuf)
			WriteFile(m_hFile, m_pBuf, m_dwPointer, &dw, NULL);
		m_dwPointer = 0;
		CFileAlternative::Flush();
	}
	void Close()
	{
		Flush();
		m_dwSize = 0;
		if(m_pBuf)
			delete []m_pBuf;
		m_pBuf = NULL;
		m_dwPointer = 0;
		CFileAlternative::Close();
	}
};

void GetDirFromFullPath(LPTSTR Dest, LPCTSTR File)
{
	TCHAR* p;
	_tcscpy(Dest, File);
	p = _tcsrchr(Dest, _T('\\'));
	if(p)
		*p = _T('\0');
}

void SetAppDir()
{
	GetModuleFileName(NULL, g_AppPath, MAX_PATH - 1);
	GetDirFromFullPath(g_AppDir, g_AppPath);
}

BOOL LoadFont()
{
	TCHAR Temp[MAX_PATH];
	LOGFONT Font;
	_stprintf(Temp, _T("%s\\msgothic.ttc"), g_AppDir);
	AddFontResource(Temp);
	SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
	ZeroMemory(&Font, sizeof(LOGFONT));
	Font.lfHeight = 16;
	Font.lfWeight = FW_NORMAL;
	Font.lfCharSet = DEFAULT_CHARSET;
	_tcscpy(Font.lfFaceName, _T("MS Gothic"));
	g_hFont = CreateFontIndirect(&Font);
	return TRUE;
}

void UnloadFont()
{
	TCHAR Temp[MAX_PATH];
	DeleteObject(g_hFont);
	_stprintf(Temp, _T("%s\\msgothic.ttc"), g_AppDir);
	RemoveFontResource(Temp);
	SendMessage(HWND_BROADCAST, WM_FONTCHANGE, 0, 0);
}

BOOL LoadDictionary()
{
	TCHAR Temp[MAX_PATH];
	CFile File;
	KANJI_DICTIONARY_HEADER Header;
	g_Preference.Timeout = 5000;
	g_Preference.TimeoutCount = 100;
	g_Preference.PointThreshold1 = -32768;
	g_Preference.PointThreshold2 = -8388608;
	g_Preference.PointThreshold3 = -1073741824;
	g_Preference.PointHistory = 128;
	g_Preference.PointChangeBunsetsu = 384;
	g_Preference.PointFuzokugo = 128;
	g_Preference.PointMultipleWord = -256;
	g_Preference.PointRelation = 384;
	g_Preference.PointNotBegin = -16777216;
	g_Preference.PointNotEnd = -16777216;
	g_Preference.PointEndYougen = 128;
	g_Preference.PointEndFuzokugo = 64;
	g_Preference.PointPreferBegin = 256;
	g_Preference.PointPreferEnd = 192;
	g_Preference.PointSequenceKatsuyou = 192;
	g_Preference.PointSequenceMeishi = 0;
	g_Preference.PointSequenceJinmei = 128;
	g_Preference.PointSequenceSuushi = 384;
	g_Preference.PointMeishiJoshi = 0;
	g_Preference.PointKatsuyouMeishi = 256;
	g_Preference.PointSettoujiJinmei = -512;
	g_Preference.PointJinmeiSetsubiji = -512;
	g_Preference.PointMultipleJiritsugo = -512;
	g_Preference.PointDifferentSuushi = -16777216;
	g_Preference.PointRelationKatsuyou = 0;
	g_Preference.PointMismatch = -16777216;
	g_Preference.PointMissPrev = -16777216;
	g_Preference.PointMissNext = -16777216;
	g_Preference.PointWrongKatsuyou = -16777216;
	g_Preference.PointMultipleChar = 256;
	g_Preference.PointMultipleBunsetsu = -256;
	g_Preference.PointDefaultLearning = 256;
	g_Preference.MinComplement = 3;
	g_Preference.MaxProofCount = 32;
	_stprintf(Temp, _T("%s\\userdict.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
	{
		_stprintf(Temp, _T("%s\\dict.dat"), g_AppDir);
		if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
			return FALSE;
	}
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		File.Close();
		return FALSE;
	}
	if(g_pDictionary)
	{
		delete []g_pDictionary;
		g_pDictionary = NULL;
		g_dwDictionary = 0;
		g_dwMaxDictionary = 0;
	}
	g_pDictionary = new KANJI_DICTIONARY[Header.Count + 512];
	if(!g_pDictionary)
	{
		File.Close();
		return FALSE;
	}
	ZeroMemory(g_pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count + 512);
	g_dwDictionary = Header.Count;
	g_dwMaxDictionary = Header.Count + 512;
	if(File.Read(g_pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		File.Close();
		return FALSE;
	}
	File.Close();
	SortDictionary(g_pDictionary, g_dwDictionary);
	_stprintf(Temp, _T("%s\\userkana.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
	{
		_stprintf(Temp, _T("%s\\kana.dat"), g_AppDir);
		if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
			return FALSE;
	}
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		File.Close();
		return FALSE;
	}
	if(g_pInputDictionary)
	{
		delete []g_pInputDictionary;
		g_pInputDictionary = NULL;
		g_dwInputDictionary = 0;
		g_dwMaxInputDictionary = 0;
	}
	g_pInputDictionary = new KANJI_DICTIONARY[Header.Count];
	if(!g_pInputDictionary)
	{
		File.Close();
		return FALSE;
	}
	ZeroMemory(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * Header.Count);
	g_dwInputDictionary = Header.Count;
	g_dwMaxInputDictionary = Header.Count;
	if(File.Read(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		File.Close();
		return FALSE;
	}
	File.Close();
	SortDictionary(g_pInputDictionary, g_dwInputDictionary);
	return TRUE;
}

BOOL LoadDefaultDictionary()
{
	TCHAR Temp[MAX_PATH];
	CFile File;
	KANJI_DICTIONARY_HEADER Header;
	_stprintf(Temp, _T("%s\\dict.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
		return FALSE;
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		File.Close();
		return FALSE;
	}
	if(g_pDictionary)
	{
		delete []g_pDictionary;
		g_pDictionary = NULL;
		g_dwDictionary = 0;
		g_dwMaxDictionary = 0;
	}
	g_pDictionary = new KANJI_DICTIONARY[Header.Count + 512];
	if(!g_pDictionary)
	{
		File.Close();
		return FALSE;
	}
	ZeroMemory(g_pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count + 512);
	g_dwDictionary = Header.Count;
	g_dwMaxDictionary = Header.Count + 512;
	if(File.Read(g_pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		File.Close();
		return FALSE;
	}
	File.Close();
	SortDictionary(g_pDictionary, g_dwDictionary);
	_stprintf(Temp, _T("%s\\kana.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeRead | CFile::shareDenyWrite, NULL))
		return FALSE;
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		File.Close();
		return FALSE;
	}
	if(g_pInputDictionary)
	{
		delete []g_pInputDictionary;
		g_pInputDictionary = NULL;
		g_dwInputDictionary = 0;
		g_dwMaxInputDictionary = 0;
	}
	g_pInputDictionary = new KANJI_DICTIONARY[Header.Count];
	if(!g_pInputDictionary)
	{
		File.Close();
		return FALSE;
	}
	ZeroMemory(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * Header.Count);
	g_dwInputDictionary = Header.Count;
	g_dwMaxInputDictionary = Header.Count;
	if(File.Read(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		File.Close();
		return FALSE;
	}
	File.Close();
	SortDictionary(g_pInputDictionary, g_dwInputDictionary);
	return TRUE;
}

void UnloadDictionary()
{
	if(g_pDictionary)
	{
		delete []g_pDictionary;
		g_pDictionary = NULL;
		g_dwDictionary = 0;
		g_dwMaxDictionary = 0;
	}
	if(g_pInputDictionary)
	{
		delete []g_pInputDictionary;
		g_pInputDictionary = NULL;
		g_dwInputDictionary = 0;
		g_dwMaxInputDictionary = 0;
	}
}

BOOL SaveDictionary()
{
	TCHAR Temp[MAX_PATH];
	CFile File;
	KANJI_DICTIONARY_HEADER Header;
	_stprintf(Temp, _T("%s\\userdict.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite, NULL))
		return FALSE;
	ZeroMemory(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	memcpy(&Header.Magic, "JIDF", 4);
	Header.Version = 0x00010000;
	Header.Count = g_dwDictionary;
	File.Write(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	File.Write(g_pDictionary, sizeof(KANJI_DICTIONARY) * g_dwDictionary);
	File.Close();
	_stprintf(Temp, _T("%s\\userkana.dat"), g_AppDir);
	if(!File.Open(Temp, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite, NULL))
		return FALSE;
	ZeroMemory(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	memcpy(&Header.Magic, "JIDF", 4);
	Header.Version = 0x00010000;
	Header.Count = g_dwInputDictionary;
	File.Write(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	File.Write(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * g_dwInputDictionary);
	File.Close();
	return TRUE;
}

BOOL AppendDictionary(LPCTSTR FileName)
{
	CFile File;
	KANJI_DICTIONARY_HEADER Header;
	if(!File.Open(FileName, CFile::modeRead | CFile::shareDenyWrite, NULL))
		return FALSE;
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		File.Close();
		return FALSE;
	}
	if(!SetDictionarySize(g_dwMaxDictionary + Header.Count))
	{
		File.Close();
		return FALSE;
	}
	if(File.Read(g_pDictionary + g_dwDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		File.Close();
		return FALSE;
	}
	g_dwDictionary += Header.Count;
	File.Close();
	SortDictionary(g_pDictionary, g_dwDictionary);
	return TRUE;
}

BOOL RegisterIME()
{
	g_KeyCodeTable[VK_RETURN] = KANJI_KEY_ENTER;
	g_KeyCodeTable[VK_BACK] = KANJI_KEY_BACK;
	g_KeyCodeTable[0x1b] = KANJI_KEY_CONVERT;
	g_KeyCodeTable[VK_LEFT] = KANJI_KEY_LEFT;
	g_KeyCodeTable[VK_UP] = KANJI_KEY_PREV;
	g_KeyCodeTable[VK_RIGHT] = KANJI_KEY_RIGHT;
	g_KeyCodeTable[VK_DOWN] = KANJI_KEY_NEXT;
//	g_KeyCodeTable[0] = KANJI_KEY_DELETE;
	g_KeyCodeTable[0xbe] = KANJI_KEY_COMBINE;
	g_KeyCodeTable['0'] = _T('0');
	g_KeyCodeTable['1'] = _T('1');
	g_KeyCodeTable['2'] = _T('2');
	g_KeyCodeTable['3'] = _T('3');
	g_KeyCodeTable['4'] = _T('4');
	g_KeyCodeTable['5'] = _T('5');
	g_KeyCodeTable['6'] = _T('6');
	g_KeyCodeTable['7'] = _T('7');
	g_KeyCodeTable['8'] = _T('8');
	g_KeyCodeTable['9'] = _T('9');
	g_KeyCodeTable['A'] = _T('a');
	g_KeyCodeTable['B'] = _T('b');
	g_KeyCodeTable['C'] = _T('c');
	g_KeyCodeTable['D'] = _T('d');
	g_KeyCodeTable['E'] = _T('e');
	g_KeyCodeTable['F'] = _T('f');
	g_KeyCodeTable['G'] = _T('g');
	g_KeyCodeTable['H'] = _T('h');
	g_KeyCodeTable['I'] = _T('i');
	g_KeyCodeTable['J'] = _T('j');
	g_KeyCodeTable['K'] = _T('k');
	g_KeyCodeTable['L'] = _T('l');
	g_KeyCodeTable['M'] = _T('m');
	g_KeyCodeTable['N'] = _T('n');
	g_KeyCodeTable['O'] = _T('o');
	g_KeyCodeTable['P'] = _T('p');
	g_KeyCodeTable['Q'] = _T('q');
	g_KeyCodeTable['R'] = _T('r');
	g_KeyCodeTable['S'] = _T('s');
	g_KeyCodeTable['T'] = _T('t');
	g_KeyCodeTable['U'] = _T('u');
	g_KeyCodeTable['V'] = _T('v');
	g_KeyCodeTable['W'] = _T('w');
	g_KeyCodeTable['X'] = _T('x');
	g_KeyCodeTable['Y'] = _T('y');
	g_KeyCodeTable['Z'] = _T('z');
	g_KeyCodeTable[VK_NUMPAD0] = _T('0');
	g_KeyCodeTable[VK_NUMPAD1] = _T('1');
	g_KeyCodeTable[VK_NUMPAD2] = _T('2');
	g_KeyCodeTable[VK_NUMPAD3] = _T('3');
	g_KeyCodeTable[VK_NUMPAD4] = _T('4');
	g_KeyCodeTable[VK_NUMPAD5] = _T('5');
	g_KeyCodeTable[VK_NUMPAD6] = _T('6');
	g_KeyCodeTable[VK_NUMPAD7] = _T('7');
	g_KeyCodeTable[VK_NUMPAD8] = _T('8');
	g_KeyCodeTable[VK_NUMPAD9] = _T('9');
	g_KeyCodeTable[0xdb] = _T(',');
	g_KeyCodeTable[0xbd] = _T('-');
	g_KeyCodeTable[VK_SPACE] = _T('-');
	g_KeyCodeTable[0xdd] = _T('.');
	return RegisterHotKey(g_hWnd, 0, 0, g_HotKeyCode);
}

void UnregisterIME()
{
	UnregisterHotKey(g_hWnd, 0);
}

void SetInputMode(DWORD Mode)
{
	if(Mode != g_InputMode)
	{
		g_InputMode = Mode;
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SetWindowPos(g_hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 16 - GetSystemMetrics(SM_CXBORDER) * 2, GetSystemMetrics(SM_CYSCREEN) - 16 - GetSystemMetrics(SM_CYBORDER) * 2, 16 + GetSystemMetrics(SM_CXBORDER) * 2, 16 + GetSystemMetrics(SM_CYBORDER) * 2, 0);
			InvalidateRect(g_hWnd, NULL, TRUE);
			break;
		case KANJI_INPUT_TYPING:
			if(g_bComplement)
				SetWindowPos(g_hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 480, GetSystemMetrics(SM_CYSCREEN) - 128, 480, 128, 0);
			else
				SetWindowPos(g_hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 480, GetSystemMetrics(SM_CYSCREEN) - 16 - GetSystemMetrics(SM_CYBORDER) * 2, 480, 16 + GetSystemMetrics(SM_CYBORDER) * 2, 0);
			InvalidateRect(g_hWnd, NULL, TRUE);
			break;
		case KANJI_INPUT_CANDIDATE:
			SetWindowPos(g_hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 480, GetSystemMetrics(SM_CYSCREEN) - 128, 480, 128, 0);
			InvalidateRect(g_hWnd, NULL, TRUE);
			break;
		case KANJI_INPUT_COMBINATION:
			break;
		}
	}
}

void SetAllKey()
{
	UINT i;
	for(i = 1; i < 256; i++)
		RegisterHotKey(g_hWnd, i, 0, i);
}

void ReleaseAllKey()
{
	UINT i;
	for(i = 1; i < 256; i++)
		UnregisterHotKey(g_hWnd, i);
}

BOOL ToggleIME()
{
	if(g_bEnableIME)
	{
		_tcscpy(g_Buffer[0], _T(""));
		g_Position = 0;
		SetInputMode(KANJI_INPUT_NONE);
		ReleaseAllKey();
		g_bEnableIME = FALSE;
	}
	else
	{
		SetAllKey();
		g_bEnableIME = TRUE;
	}
	_tcscpy(g_Buffer[0], _T(""));
	g_Position = 0;
	g_Result[0].pKanji[0] = NULL;
	InvalidateRect(g_hWnd, NULL, TRUE);
	return TRUE;
}

void SendMessageString(LPCTSTR String)
{
	UINT Temp;
	UINT* pTemp1;
	UINT* pTemp2;
	Temp = (UINT)_tcslen(String);
	pTemp1 = new UINT[Temp * 2];
	if(!pTemp1)
		return;
	pTemp2 = pTemp1;
	while(*String != _T('\0'))
	{
		*pTemp2 = *String;
		pTemp2++;
		String++;
	}
	ZeroMemory(pTemp2, sizeof(UINT) * Temp);
	PostKeybdMessage((HWND)-1, 0, 0, Temp, pTemp2, pTemp1);
	delete []pTemp1;
}

void SendMessageKeyCode(UINT Key)
{
	INPUT Input;
	UnregisterHotKey(g_hWnd, Key);
	ZeroMemory(&Input, sizeof(INPUT));
	Input.type = INPUT_KEYBOARD;
	Input.ki.wVk = (WORD)Key;
	SendInput(1, &Input, sizeof(INPUT));
	Input.ki.dwFlags = KEYEVENTF_KEYUP;
	SendInput(1, &Input, sizeof(INPUT));
	RegisterHotKey(g_hWnd, Key, 0, Key);
}

void SetCommandCandidate(TCHAR* Kanji)
{
	ZeroMemory(&g_KanaCommandDictionary[g_dwKanaCommandDictionary], sizeof(KANJI_DICTIONARY));
	ZeroMemory(&g_Candidate[g_dwKanaCommandDictionary], sizeof(KANJI_BUNSETSU_CANDIDATE));
	_tcscpy(g_KanaCommandDictionary[g_dwKanaCommandDictionary].Kanji, Kanji);
	g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = &g_KanaCommandDictionary[g_dwKanaCommandDictionary];
	g_dwKanaCommandDictionary++;
}

BOOL ConvertKanaCommand(TCHAR* Kana)
{
	TCHAR str[256];
	SYSTEMTIME st;
	TCHAR* Week[2][7];
	DWORD i;
	if(_tcscmp(Kana, _T("[[ւ")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = TRUE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(_T("Japanese Input"));
		SetCommandCandidate(_T("R}hɂ"));
		SetCommandCandidate(_T("[[ւ"));
		SetCommandCandidate(_T("̐\"));
		SetCommandCandidate(_T("[["));
		SetCommandCandidate(_T("҂̖O\"));
		SetCommandCandidate(_T("[[΁["));
		SetCommandCandidate(_T("݂̃o[W\"));
		SetCommandCandidate(_T("[["));
		SetCommandCandidate(_T("݂̎\"));
		SetCommandCandidate(_T("[[ЂÂ"));
		SetCommandCandidate(_T("݂̓t\"));
		SetCommandCandidate(_T("[[ꂫ"));
		SetCommandCandidate(_T("ϊ\"));
		SetCommandCandidate(_T("[[["));
		SetCommandCandidate(_T("wKL^ۑ"));
		SetCommandCandidate(_T("[[["));
		SetCommandCandidate(_T("wKL^ǂݍ"));
		SetCommandCandidate(_T("[[肹"));
		SetCommandCandidate(_T("wKL^j"));
		SetCommandCandidate(_T("[["));
		SetCommandCandidate(_T("̃\tgI"));
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = FALSE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(AUTHOR_STRING);
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[΁[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = FALSE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(VERSION_STRING);
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = FALSE;
		g_dwKanaCommandDictionary = 0;
		GetLocalTime(&st);
		_stprintf(str, _T("%u%02u%02ub"), st.wHour, st.wMinute, st.wSecond);
		SetCommandCandidate(str);
		if(st.wHour < 12)
			_stprintf(str, _T("ߑO%u%02u%02ub"), st.wHour, st.wMinute, st.wSecond);
		else if(st.wHour == 12)
			_stprintf(str, _T("ߌ%u%02u%02ub"), st.wHour, st.wMinute, st.wSecond);
		else
			_stprintf(str, _T("ߌ%u%02u%02ub"), st.wHour - 12, st.wMinute, st.wSecond);
		SetCommandCandidate(str);
		_stprintf(str, _T("%02u:%02u:%02u"), st.wHour, st.wMinute, st.wSecond);
		SetCommandCandidate(str);
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[ЂÂ")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = FALSE;
		g_dwKanaCommandDictionary = 0;
		GetLocalTime(&st);
		Week[0][0] = _T("");
		Week[0][1] = _T("");
		Week[0][2] = _T("");
		Week[0][3] = _T("");
		Week[0][4] = _T("");
		Week[0][5] = _T("");
		Week[0][6] = _T("y");
		Week[1][0] = _T("Sun");
		Week[1][1] = _T("Mon");
		Week[1][2] = _T("Tue");
		Week[1][3] = _T("Wed");
		Week[1][4] = _T("Thu");
		Week[1][5] = _T("Fri");
		Week[1][6] = _T("Sat");
		_stprintf(str, _T("%uN%u%u"), st.wYear, st.wMonth, st.wDay);
		SetCommandCandidate(str);
		_stprintf(str, _T("%uN%u%u(%s)"), st.wYear, st.wMonth, st.wDay, Week[0][st.wDayOfWeek]);
		SetCommandCandidate(str);
		_stprintf(str, _T("%u/%02u/%02u"), st.wYear, st.wMonth, st.wDay);
		SetCommandCandidate(str);
		_stprintf(str, _T("%02u/%02u/%u"), st.wMonth, st.wDay, st.wYear);
		SetCommandCandidate(str);
		_stprintf(str, _T("%02u/%02u/%u %s"), st.wMonth, st.wDay, st.wYear, Week[1][st.wDayOfWeek]);
		SetCommandCandidate(str);
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[ꂫ")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = FALSE;
		g_dwKanaCommandDictionary = 0;
		if(g_HistoryCount > 64)
		{
			for(i = 1; i <= 64; i++)
				SetCommandCandidate(g_History[(g_HistoryCount - i) % 64]);
		}
		else if(g_HistoryCount > 0)
		{
			for(i = 1; i <= g_HistoryCount; i++)
				SetCommandCandidate(g_History[(g_HistoryCount - i) % 64]);
		}
		else
		{
			g_bKanaCommandMenu = TRUE;
			SetCommandCandidate(_T("ϊ܂"));
		}
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = TRUE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(_T("wKۑ"));
		SetCommandCandidate(_T("LZ"));
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = TRUE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(_T("wKǂݍ"));
		SetCommandCandidate(_T("LZ"));
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[肹")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = TRUE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(_T("wKj"));
		SetCommandCandidate(_T("LZ"));
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	else if(_tcscmp(Kana, _T("[[")) == 0)
	{
		g_bKanaCommand = TRUE;
		g_bKanaCommandMenu = TRUE;
		g_dwKanaCommandDictionary = 0;
		SetCommandCandidate(_T("̃\tgI"));
		SetCommandCandidate(_T("LZ"));
		g_Candidate[g_dwKanaCommandDictionary].Data.pKanji[0] = NULL;
		g_Result[0] = g_Candidate[0].Data;
		g_Result[1].pKanji[0] = NULL;
		g_Position = 0;
		g_CandidatePosition = 0;
		g_dwCandidate = g_dwKanaCommandDictionary;
		return TRUE;
	}
	g_bKanaCommand = FALSE;
	g_bKanaCommandMenu = FALSE;
	return FALSE;
}

void ExecKanaCommand(TCHAR* Kana, TCHAR* Kanji)
{
	if(_tcscmp(Kana, _T("[[[")) == 0)
	{
		if(_tcscmp(Kanji, _T("wKۑ")) == 0)
			PostMessage(g_hWnd, WM_USER, 0, 0);
	}
	else if(_tcscmp(Kana, _T("[[[")) == 0)
	{
		if(_tcscmp(Kanji, _T("wKǂݍ")) == 0)
			PostMessage(g_hWnd, WM_USER, 1, 0);
	}
	else if(_tcscmp(Kana, _T("[[肹")) == 0)
	{
		if(_tcscmp(Kanji, _T("wKj")) == 0)
			PostMessage(g_hWnd, WM_USER, 2, 0);
	}
	else if(_tcscmp(Kana, _T("[[")) == 0)
	{
		if(_tcscmp(Kanji, _T("̃\tgI")) == 0)
			PostMessage(g_hWnd, WM_CLOSE, 0, 0);
	}
}

void OnKeyPressed(UINT Key)
{
	DWORD i;
	DWORD j;
	TCHAR* p1;
	TCHAR* p2;
	TCHAR* ps1;
	TCHAR* ps2;
	ResetTimeout();
	switch(g_KeyCodeTable[LOWORD(Key) & 0x00ff])
	{
	case KANJI_KEY_ENTER:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			SendMessageString(g_Buffer[0]);
			_tcscpy(g_Buffer[0], _T(""));
			g_Position = 0;
			SetInputMode(KANJI_INPUT_NONE);
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_bKanaCommandMenu)
			{
				ExecKanaCommand(g_Buffer[0], g_Result[0].pKanji[0]->Kanji);
				_tcscpy(g_Buffer[0], _T(""));
				g_Position = 0;
				SetInputMode(KANJI_INPUT_NONE);
				break;
			}
			_tcscpy(g_Buffer[0], _T(""));
			if(g_bKanaCommand)
			{
				i = 0;
				while(g_Result[i].pKanji[0])
				{
					j = 0;
					while(g_Result[i].pKanji[j])
					{
						_tcscat(g_Buffer[0], g_Result[i].pKanji[j]->Kanji);
						j++;
					}
					i++;
				}
			}
			else
			{
				i = 0;
				g_dwConvert = 0;
				g_dwLearning = 0;
				p1 = g_Kana[0];
				p2 = g_Kana[2];
				ps1 = p1;
				ps2 = p2;
				while(g_Result[i].pKanji[0])
				{
					j = 0;
					while(g_Result[i].pKanji[j])
					{
						if(!(g_Result[i].pKanji[j]->Type & KANJI_TYPE_FUZOKUGO) && g_Result[i].pKanji[j]->Kana[0] != KANJI_INVALID_CHAR)
						{
							if(g_Result[i].pKanji[j] >= g_pDictionary && g_Result[i].pKanji[j] < g_pDictionary + g_dwDictionary)
							{
								g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, i, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
								if(g_dwCandidate == 0 || CompareBunsetsu(&g_Candidate[0].Data, &g_Result[i]) != 0)
									g_Result[i].pKanji[j]->Point += g_Preference.PointHistory;
								else if(_tcscmp(ps1, ps2) != 0)
									g_Result[i].pKanji[j]->Point += g_Preference.PointChangeBunsetsu;
								g_pConvert[g_dwConvert] = g_Result[i].pKanji[j];
								g_dwConvert++;
							}
							else
							{
								g_pLearning[g_dwLearning] = g_Result[i].pKanji[j];
								g_dwLearning++;
							}
						}
						if(!(g_Result[i].pKanji[j]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)) && g_Result[i].pKanji[j]->Kana[0] != KANJI_INVALID_CHAR)
						{
							if(_tcscmp(ps1, ps2) != 0)
								g_Result[i].pKanji[j]->Point += g_Preference.PointFuzokugo;
						}
						_tcscat(g_Buffer[0], g_Result[i].pKanji[j]->Kanji);
						j++;
					}
					j = 0;
					while(g_Result[i].Kana[j] != _T('\0'))
					{
						p1++;
						p2++;
						if(*p1 == _T('\0'))
						{
							p1++;
							ps1 = p1;
						}
						if(*p2 == _T('\0'))
						{
							p2++;
							ps2 = p2;
						}
						j++;
					}
					i++;
				}
				SetDictionaryDataToKanaTop((KANJI_DICTIONARY**)&g_pConvert, g_dwConvert);
				if(g_dwLearning > 0)
				{
					for(i = 0; i < g_dwLearning; i++)
					{
						if(g_pLearning[i]->Kana[0] != KANJI_INVALID_CHAR)
							SetDictionaryDataToTop(g_pLearning[i], 1);
					}
					SortDictionary(g_pDictionary, g_dwDictionary);
					TrimDictionaryData();
				}
			}
			SendMessageString(g_Buffer[0]);
			_tcscpy(g_History[g_HistoryCount % 64], g_Buffer[0]);
			g_HistoryCount++;
			_tcscpy(g_Buffer[0], _T(""));
			g_Position = 0;
			SetInputMode(KANJI_INPUT_NONE);
			break;
		case KANJI_INPUT_COMBINATION:
			g_dwTempDictionary = 0;
			ProofKanaToBunsetsu(g_pDictionary, g_dwDictionary, g_Kana[0], (KANJI_BUNSETSU*)&g_Result);
			g_Position = 0;
			g_CandidatePosition = 0;
			g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, g_Position, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
			while(g_CandidatePosition < g_dwCandidate && CompareBunsetsu(&g_Candidate[g_CandidatePosition].Data, &g_Result[g_Position]) != 0)
			{
				g_CandidatePosition++;
			}
			SetInputMode(KANJI_INPUT_CANDIDATE);
			break;
		case KANJI_INPUT_COMPLEMENT:
			_tcscpy(g_Buffer[0], _T(""));
			i = 0;
			while(g_Result[0].pKanji[i])
			{
				if(!(g_Result[0].pKanji[i]->Type & KANJI_TYPE_FUZOKUGO) && g_Result[0].pKanji[i]->Kana[0] != KANJI_INVALID_CHAR)
				{
					if(g_Result[0].pKanji[i] >= g_pDictionary && g_Result[0].pKanji[i] < g_pDictionary + g_dwDictionary)
					{
						if(g_CandidatePosition > 0)
							g_Result[0].pKanji[i]->Point += g_Preference.PointHistory;
					}
				}
				_tcscat(g_Buffer[0], g_Result[0].pKanji[i]->Kanji);
				i++;
			}
			SendMessageString(g_Buffer[0]);
			_tcscpy(g_History[g_HistoryCount % 64], g_Buffer[0]);
			g_HistoryCount++;
			_tcscpy(g_Buffer[0], _T(""));
			g_Position = 0;
			SetInputMode(KANJI_INPUT_NONE);
			break;
		}
		break;
	case KANJI_KEY_CONVERT:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
//			SendMessageKeyCode(Key);
			SendMessageString(_T("@"));
			break;
		case KANJI_INPUT_TYPING:
			if(!ConvertKanaCommand(g_Buffer[0]))
			{
				g_dwTempDictionary = 0;
				ConvertKanaToBunsetsu(g_pDictionary, g_dwDictionary, g_Buffer[0], _tcslen(g_Buffer[0]), (KANJI_BUNSETSU*)&g_Result);
				g_Position = 0;
				g_CandidatePosition = 0;
				g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, g_Position, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
				while(g_CandidatePosition < g_dwCandidate && CompareBunsetsu(&g_Candidate[g_CandidatePosition].Data, &g_Result[g_Position]) != 0)
				{
					g_CandidatePosition++;
				}
				GetKanaFromBunsetsu((KANJI_BUNSETSU*)&g_Result, g_Kana[0]);
				memcpy(&g_Kana[2], &g_Kana[0], sizeof(TCHAR) * 256);
			}
			SetInputMode(KANJI_INPUT_CANDIDATE);
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_dwCandidate > 0)
			{
				if(g_CandidatePosition + 1 < g_dwCandidate)
					g_CandidatePosition++;
				else
					g_CandidatePosition = 0;
				g_Result[g_Position] = g_Candidate[g_CandidatePosition].Data;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			g_dwTempDictionary = 0;
			ProofKanaToBunsetsu(g_pDictionary, g_dwDictionary, g_Kana[0], (KANJI_BUNSETSU*)&g_Result);
			g_Position = 0;
			g_CandidatePosition = 0;
			g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, g_Position, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
			while(g_CandidatePosition < g_dwCandidate && CompareBunsetsu(&g_Candidate[g_CandidatePosition].Data, &g_Result[g_Position]) != 0)
			{
				g_CandidatePosition++;
			}
			SetInputMode(KANJI_INPUT_CANDIDATE);
			break;
		case KANJI_INPUT_COMPLEMENT:
			break;
		}
		break;
	case KANJI_KEY_BACK:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_Position > 0)
			{
				g_Position--;
				RemoveChar(g_Buffer[0], g_Position);
			}
			if(_tcslen(g_Buffer[0]) == 0)
				SetInputMode(KANJI_INPUT_NONE);
			break;
		case KANJI_INPUT_CANDIDATE:
			g_Position = (DWORD)_tcslen(g_Buffer[0]);
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		case KANJI_INPUT_COMBINATION:
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		case KANJI_INPUT_COMPLEMENT:
			g_Position = (DWORD)_tcslen(g_Buffer[0]);
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		}
		break;
	case KANJI_KEY_DELETE:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_Position < (DWORD)_tcslen(g_Buffer[0]))
				RemoveChar(g_Buffer[0], g_Position);
			if(_tcslen(g_Buffer[0]) == 0)
				SetInputMode(KANJI_INPUT_NONE);
			break;
		case KANJI_INPUT_CANDIDATE:
			g_Position = (DWORD)_tcslen(g_Buffer[0]);
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		case KANJI_INPUT_COMBINATION:
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		case KANJI_INPUT_COMPLEMENT:
			g_Position = (DWORD)_tcslen(g_Buffer[0]);
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		}
		break;
	case KANJI_KEY_LEFT:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_Position > 0)
				g_Position--;
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_bKanaCommand)
				break;
			if(g_Position > 0)
				g_Position--;
			g_CandidatePosition = 0;
			g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, g_Position, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
			while(g_CandidatePosition < g_dwCandidate && CompareBunsetsu(&g_Candidate[g_CandidatePosition].Data, &g_Result[g_Position]) != 0)
			{
				g_CandidatePosition++;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			if(g_Position > 0)
				g_Position--;
			break;
		case KANJI_INPUT_COMPLEMENT:
			break;
		}
		break;
	case KANJI_KEY_RIGHT:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_Position < (DWORD)_tcslen(g_Buffer[0]))
				g_Position++;
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_bKanaCommand)
				break;
			if(g_Result[g_Position + 1].pKanji[0])
				g_Position++;
			g_CandidatePosition = 0;
			g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, g_Position, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
			while(g_CandidatePosition < g_dwCandidate && CompareBunsetsu(&g_Candidate[g_CandidatePosition].Data, &g_Result[g_Position]) != 0)
			{
				g_CandidatePosition++;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			if(g_Position < (DWORD)_tcslen(g_Buffer[0]))
				g_Position++;
			break;
		case KANJI_INPUT_COMPLEMENT:
			break;
		}
		break;
	case KANJI_KEY_PREV:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_dwCandidate > 0)
			{
				g_Position = 0;
				g_CandidatePosition = 0;
				g_Result[0] = g_Candidate[g_CandidatePosition].Data;
				g_Result[1].pKanji[0] = NULL;
				SetInputMode(KANJI_INPUT_COMPLEMENT);
			}
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_dwCandidate > 0)
			{
				if(g_CandidatePosition > 0)
					g_CandidatePosition--;
				else
					g_CandidatePosition = g_dwCandidate - 1;
				g_Result[g_Position] = g_Candidate[g_CandidatePosition].Data;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			i = 0;
			p1 = g_Kana[0];
			p2 = g_Kana[1];
			while(p1[0] != _T('\0') || p1[1] != _T('\0'))
			{
				if(*p1 != _T('\0'))
					i++;
				*p2 = *p1;
				*p1++;
				*p2++;
				if(i == g_Position)
				{
					i++;
					if(p1[0] == _T('\0') && p1[1] != _T('\0'))
						p1++;
				}
			}
			p2[0] = _T('\0');
			p2[1] = _T('\0');
			memcpy(&g_Kana[0], &g_Kana[1], sizeof(TCHAR) * 256);
			break;
		case KANJI_INPUT_COMPLEMENT:
			if(g_dwCandidate > 0)
			{
				if(g_CandidatePosition > 0)
					g_CandidatePosition--;
				else
					g_CandidatePosition = g_dwCandidate - 1;
				g_Result[g_Position] = g_Candidate[g_CandidatePosition].Data;
			}
			break;
		}
		break;
	case KANJI_KEY_NEXT:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_TYPING:
			if(g_dwCandidate > 0)
			{
				g_Position = 0;
				g_CandidatePosition = 0;
				g_Result[0] = g_Candidate[g_CandidatePosition].Data;
				g_Result[1].pKanji[0] = NULL;
				SetInputMode(KANJI_INPUT_COMPLEMENT);
			}
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_dwCandidate > 0)
			{
				if(g_CandidatePosition + 1 < g_dwCandidate)
					g_CandidatePosition++;
				else
					g_CandidatePosition = 0;
				g_Result[g_Position] = g_Candidate[g_CandidatePosition].Data;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			i = 0;
			p1 = g_Kana[0];
			p2 = g_Kana[1];
			while(p1[0] != _T('\0') || p1[1] != _T('\0'))
			{
				if(*p1 != _T('\0'))
					i++;
				*p2 = *p1;
				*p1++;
				*p2++;
				if(i == g_Position)
				{
					i++;
					if(*p1 != _T('\0'))
					{
						*p2 = _T('\0');
						p2++;
					}
				}
			}
			p2[0] = _T('\0');
			p2[1] = _T('\0');
			memcpy(&g_Kana[0], &g_Kana[1], sizeof(TCHAR) * 256);
			break;
		case KANJI_INPUT_COMPLEMENT:
			if(g_dwCandidate > 0)
			{
				if(g_CandidatePosition + 1 < g_dwCandidate)
					g_CandidatePosition++;
				else
					g_CandidatePosition = 0;
				g_Result[g_Position] = g_Candidate[g_CandidatePosition].Data;
			}
			break;
		}
		break;
	case KANJI_KEY_COMBINE:
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			if(g_bConvert)
				g_bConvert = FALSE;
			else
				g_bConvert = TRUE;
			InvalidateRect(g_hWnd, NULL, TRUE);
			break;
		case KANJI_INPUT_TYPING:
			if(g_bComplement)
				g_bComplement = FALSE;
			else
				g_bComplement = TRUE;
			SetInputMode(KANJI_INPUT_NONE);
			SetInputMode(KANJI_INPUT_TYPING);
			break;
		case KANJI_INPUT_CANDIDATE:
			if(g_bKanaCommand)
				break;
			g_Position = (DWORD)_tcslen(g_Buffer[0]);
			SetInputMode(KANJI_INPUT_COMBINATION);
			break;
		case KANJI_INPUT_COMBINATION:
			break;
		case KANJI_INPUT_COMPLEMENT:
			break;
		}
		break;
	default:
		switch(g_InputMode)
		{
		case KANJI_INPUT_CANDIDATE:
			if(g_bKanaCommandMenu)
			{
//				ExecKanaCommand(g_Buffer[0], g_Result[0].pKanji[0]->Kanji);
				_tcscpy(g_Buffer[0], _T(""));
				g_Position = 0;
				SetInputMode(KANJI_INPUT_NONE);
				break;
			}
			_tcscpy(g_Buffer[0], _T(""));
			if(g_bKanaCommand)
			{
				i = 0;
				while(g_Result[i].pKanji[0])
				{
					j = 0;
					while(g_Result[i].pKanji[j])
					{
						_tcscat(g_Buffer[0], g_Result[i].pKanji[j]->Kanji);
						j++;
					}
					i++;
				}
			}
			else
			{
				i = 0;
				g_dwConvert = 0;
				g_dwLearning = 0;
				p1 = g_Kana[0];
				p2 = g_Kana[2];
				ps1 = p1;
				ps2 = p2;
				while(g_Result[i].pKanji[0])
				{
					j = 0;
					while(g_Result[i].pKanji[j])
					{
						if(!(g_Result[i].pKanji[j]->Type & KANJI_TYPE_FUZOKUGO) && g_Result[i].pKanji[j]->Kana[0] != KANJI_INVALID_CHAR)
						{
							if(g_Result[i].pKanji[j] >= g_pDictionary && g_Result[i].pKanji[j] < g_pDictionary + g_dwDictionary)
							{
								g_dwCandidate = EnumBunsetsuCandidate(g_pDictionary, g_dwDictionary, (KANJI_BUNSETSU*)&g_Result, i, (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
								if(g_dwCandidate == 0 || CompareBunsetsu(&g_Candidate[0].Data, &g_Result[i]) != 0)
									g_Result[i].pKanji[j]->Point += g_Preference.PointHistory;
								else if(_tcscmp(ps1, ps2) != 0)
									g_Result[i].pKanji[j]->Point += g_Preference.PointChangeBunsetsu;
								g_pConvert[g_dwConvert] = g_Result[i].pKanji[j];
								g_dwConvert++;
							}
							else
							{
								g_pLearning[g_dwLearning] = g_Result[i].pKanji[j];
								g_dwLearning++;
							}
						}
						if(!(g_Result[i].pKanji[j]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)) && g_Result[i].pKanji[j]->Kana[0] != KANJI_INVALID_CHAR)
						{
							if(_tcscmp(ps1, ps2) != 0)
								g_Result[i].pKanji[j]->Point += g_Preference.PointFuzokugo;
						}
						_tcscat(g_Buffer[0], g_Result[i].pKanji[j]->Kanji);
						j++;
					}
					j = 0;
					while(g_Result[i].Kana[j] != _T('\0'))
					{
						p1++;
						p2++;
						if(*p1 == _T('\0'))
						{
							p1++;
							ps1 = p1;
						}
						if(*p2 == _T('\0'))
						{
							p2++;
							ps2 = p2;
						}
						j++;
					}
					i++;
				}
				SetDictionaryDataToKanaTop((KANJI_DICTIONARY**)&g_pConvert, g_dwConvert);
				if(g_dwLearning > 0)
				{
					for(i = 0; i < g_dwLearning; i++)
					{
						if(g_pLearning[i]->Kana[0] != KANJI_INVALID_CHAR)
							SetDictionaryDataToTop(g_pLearning[i], 1);
					}
					SortDictionary(g_pDictionary, g_dwDictionary);
					TrimDictionaryData();
				}
			}
			SendMessageString(g_Buffer[0]);
			_tcscpy(g_History[g_HistoryCount % 64], g_Buffer[0]);
			g_HistoryCount++;
			_tcscpy(g_Buffer[0], _T(""));
			g_Position = 0;
			SetInputMode(KANJI_INPUT_NONE);
		case KANJI_INPUT_NONE:
		case KANJI_INPUT_TYPING:
		case KANJI_INPUT_COMBINATION:
			if(g_KeyCodeTable[LOWORD(Key) & 0x00ff] != _T('\0'))
			{
				InsertChar(g_Buffer[0], g_KeyCodeTable[LOWORD(Key) & 0x00ff], g_Position);
				g_Position++;
				SetInputMode(KANJI_INPUT_TYPING);
			}
			else if(g_InputMode == KANJI_INPUT_NONE)
				SendMessageKeyCode(Key);
			break;
		case KANJI_INPUT_COMPLEMENT:
			_tcscpy(g_Buffer[0], _T(""));
			i = 0;
			while(g_Result[0].pKanji[i])
			{
				if(!(g_Result[0].pKanji[i]->Type & KANJI_TYPE_FUZOKUGO) && g_Result[0].pKanji[i]->Kana[0] != KANJI_INVALID_CHAR)
				{
					if(g_Result[0].pKanji[i] >= g_pDictionary && g_Result[0].pKanji[i] < g_pDictionary + g_dwDictionary)
					{
						if(g_CandidatePosition > 0)
							g_Result[0].pKanji[i]->Point += g_Preference.PointHistory;
					}
				}
				_tcscat(g_Buffer[0], g_Result[0].pKanji[i]->Kanji);
				i++;
			}
			SendMessageString(g_Buffer[0]);
			_tcscpy(g_History[g_HistoryCount % 64], g_Buffer[0]);
			g_HistoryCount++;
			_tcscpy(g_Buffer[0], _T(""));
			g_Position = 0;
			SetInputMode(KANJI_INPUT_NONE);
			if(g_KeyCodeTable[LOWORD(Key) & 0x00ff] != _T('\0'))
			{
				InsertChar(g_Buffer[0], g_KeyCodeTable[LOWORD(Key) & 0x00ff], g_Position);
				g_Position++;
				SetInputMode(KANJI_INPUT_TYPING);
			}
			else if(g_InputMode == KANJI_INPUT_NONE)
				SendMessageKeyCode(Key);
			break;
		}
		break;
	}
	if(g_InputMode == KANJI_INPUT_TYPING)
	{
		if(g_bConvert)
		{
			ConvertInputToKana(g_pInputDictionary, g_dwInputDictionary, g_Buffer[0], _tcslen(g_Buffer[0]), g_Buffer[1]);
			g_Position += (DWORD)((LONG)_tcslen(g_Buffer[1]) - (LONG)_tcslen(g_Buffer[0]));
			_tcscpy(g_Buffer[0], g_Buffer[1]);
		}
		g_Buffer[0][KANJI_MAX_WORD - 1] = _T('\0');
		if(g_Position > KANJI_MAX_WORD - 1)
			g_Position = KANJI_MAX_WORD - 1;
		if(g_bComplement)
		{
			g_CandidatePosition = 0;
			if((DWORD)_tcslen(g_Buffer[0]) >= g_Preference.MinComplement)
				g_dwCandidate = EnumBunsetsuComplement(g_pDictionary, g_dwDictionary, g_Buffer[0], (KANJI_BUNSETSU_CANDIDATE*)&g_Candidate);
			else
				g_dwCandidate = 0;
		}
	}
	if(g_InputMode != KANJI_INPUT_NONE)
		InvalidateRect(g_hWnd, NULL, TRUE);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	HDC hDC;
	PAINTSTRUCT ps;
	RECT rc;
	DWORD i;
	LONG j;
	LONG k;
	DWORD l;
	TCHAR str[2][256];
	TCHAR* p;
	switch(uMsg)
	{
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	case WM_PAINT:
		hDC = BeginPaint(hWnd, &ps);
		SelectObject(hDC, g_hFont);
		SetBkColor(hDC, RGB(255, 255, 255));
		GetClientRect(hWnd, &rc);
		rc.left = rc.right - 16;
		rc.top = rc.bottom - 16;
		if(g_bEnableIME)
		{
			if(g_bConvert)
				DrawText(hDC, _T(""), _tcslen(_T("")), &rc, DT_LEFT);
			else
				DrawText(hDC, _T("`"), _tcslen(_T("`")), &rc, DT_LEFT);
		}
		else
			DrawText(hDC, _T("Aa"), _tcslen(_T("Aa")), &rc, DT_LEFT);
		switch(g_InputMode)
		{
		case KANJI_INPUT_NONE:
			break;
		case KANJI_INPUT_TYPING:
			GetClientRect(hWnd, &rc);
			DrawText(hDC, g_Buffer[0], _tcslen(g_Buffer[0]), &rc, DT_LEFT | DT_TOP);
			rc.left = 0;
			rc.top = 0;
			DrawText(hDC, g_Buffer[0], g_Position, &rc, DT_LEFT | DT_TOP | DT_CALCRECT);
			if(g_Position == 0)
				rc.right = 0;
			rc.left = rc.right;
			rc.right = rc.left + 1;
			rc.bottom = rc.top + 16;
			FillRect(hDC, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
			if(g_bComplement)
			{
				i = (g_CandidatePosition / 6) * 6;
				l = i + 6;
				if(l > g_dwCandidate)
					l = g_dwCandidate;
				GetClientRect(hWnd, &rc);
				rc.bottom = 24;
				while(i < l)
				{
					rc.top = rc.bottom;
					rc.bottom += 16;
					j = 0;
					_stprintf(str[0], _T("%2u "), i + 1);
					while(g_Candidate[i].Data.pKanji[j])
					{
						_tcscat(str[0], g_Candidate[i].Data.pKanji[j]->Kanji);
						j++;
					}
					_tcscat(str[0], _T(" "));
					GetBunsetsuTypeString(&g_Candidate[i].Data, str[1]);
					_tcscat(str[0], str[1]);
					DrawText(hDC, str[0], _tcslen(str[0]), &rc, DT_LEFT | DT_TOP);
					i++;
				}
			}
			break;
		case KANJI_INPUT_CANDIDATE:
			i = 0;
			j = 0;
			while(g_Result[i].pKanji[0])
			{
				rc.left = 0;
				rc.top = 0;
				k = 0;
				str[0][0] = _T('\0');
				while(g_Result[i].pKanji[k])
				{
					_tcscat(str[0], g_Result[i].pKanji[k]->Kanji);
					k++;
				}
				DrawText(hDC, str[0], _tcslen(str[0]), &rc, DT_LEFT | DT_TOP | DT_CALCRECT);
				k = rc.right;
				rc.left += j;
				rc.right += j;
				j += k;
				DrawText(hDC, str[0], _tcslen(str[0]), &rc, DT_LEFT | DT_TOP);
				rc.left += 1;
				rc.top = rc.bottom + 1;
				rc.right -= 1;
				if(i == g_Position)
					rc.bottom += 3;
				else
					rc.bottom += 2;
				FillRect(hDC, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
				i++;
			}
			i = (g_CandidatePosition / 6) * 6;
			l = i + 6;
			if(l > g_dwCandidate)
				l = g_dwCandidate;
			GetClientRect(hWnd, &rc);
			rc.bottom = 24;
			while(i < l)
			{
				rc.top = rc.bottom;
				rc.bottom += 16;
				j = 0;
				_stprintf(str[0], _T("%2u "), i + 1);
				while(g_Candidate[i].Data.pKanji[j])
				{
					_tcscat(str[0], g_Candidate[i].Data.pKanji[j]->Kanji);
					j++;
				}
				_tcscat(str[0], _T(" "));
				GetBunsetsuTypeString(&g_Candidate[i].Data, str[1]);
				_tcscat(str[0], str[1]);
				if(i == g_CandidatePosition)
					SetBkColor(hDC, RGB(128, 255, 255));
				else
					SetBkColor(hDC, RGB(255, 255, 255));
				DrawText(hDC, str[0], _tcslen(str[0]), &rc, DT_LEFT | DT_TOP);
				i++;
			}
			break;
		case KANJI_INPUT_COMBINATION:
			j = 0;
			p = g_Kana[0];
			while(*p != _T('\0'))
			{
				rc.left = 0;
				rc.top = 0;
				DrawText(hDC, p, _tcslen(p), &rc, DT_LEFT | DT_TOP | DT_CALCRECT);
				k = rc.right;
				rc.left += j;
				rc.right += j;
				j += k;
				DrawText(hDC, p, _tcslen(p), &rc, DT_LEFT | DT_TOP);
				p += _tcslen(p) + 1;
				rc.left += 1;
				rc.top = rc.bottom + 2;
				rc.right -= 1;
				rc.bottom += 1;
				FillRect(hDC, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
			}
			rc.left = 0;
			rc.top = 0;
			DrawText(hDC, g_Buffer[0], g_Position, &rc, DT_LEFT | DT_TOP | DT_CALCRECT);
			if(g_Position == 0)
				rc.right = 0;
			rc.left = rc.right;
			rc.right = rc.left + 1;
			FillRect(hDC, &rc, (HBRUSH)GetStockObject(BLACK_BRUSH));
			break;
		case KANJI_INPUT_COMPLEMENT:
			GetClientRect(hWnd, &rc);
			DrawText(hDC, g_Buffer[0], _tcslen(g_Buffer[0]), &rc, DT_LEFT | DT_TOP);
			i = (g_CandidatePosition / 6) * 6;
			l = i + 6;
			if(l > g_dwCandidate)
				l = g_dwCandidate;
			GetClientRect(hWnd, &rc);
			rc.bottom = 24;
			while(i < l)
			{
				rc.top = rc.bottom;
				rc.bottom += 16;
				j = 0;
				_stprintf(str[0], _T("%2u "), i + 1);
				while(g_Candidate[i].Data.pKanji[j])
				{
					_tcscat(str[0], g_Candidate[i].Data.pKanji[j]->Kanji);
					j++;
				}
				_tcscat(str[0], _T(" "));
				GetBunsetsuTypeString(&g_Candidate[i].Data, str[1]);
				_tcscat(str[0], str[1]);
				if(i == g_CandidatePosition)
					SetBkColor(hDC, RGB(128, 255, 255));
				else
					SetBkColor(hDC, RGB(255, 255, 255));
				DrawText(hDC, str[0], _tcslen(str[0]), &rc, DT_LEFT | DT_TOP);
				i++;
			}
			break;
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_HOTKEY:
		if(!g_bKeyLock)
		{
			g_bKeyLock = TRUE;
			if(wParam == 0)
				ToggleIME();
			else
				OnKeyPressed((UINT)wParam);
			g_bKeyLock = FALSE;
		}
		else
			SendMessageKeyCode((UINT)wParam);
		break;
	case WM_USER:
		switch(wParam)
		{
		case 0:
			SaveDictionary();
			break;
		case 1:
			LoadDictionary();
			break;
		case 2:
			LoadDefaultDictionary();
			break;
		}
		break;
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS Class;
	MSG msg;
	SetAppDir();
	if(FindWindow(_T("Japanese Input for SHARP Brain"), NULL))
		return 0;
	if(!LoadFont())
		return 0;
	if(!LoadDictionary())
		return 0;
	g_HotKeyCode = 0xbc;
	g_bConvert = TRUE;
	g_hInstance = hInstance;
	ZeroMemory(&Class, sizeof(WNDCLASS));
	Class.style = CS_HREDRAW | CS_VREDRAW;
	Class.lpfnWndProc = (WNDPROC)WndProc;
	Class.hInstance = g_hInstance;
	Class.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	Class.lpszClassName = _T("Japanese Input for SHARP Brain");
	if(!RegisterClass(&Class))
		return 0;
	g_hWnd = CreateWindowEx(WS_EX_NOACTIVATE, Class.lpszClassName, _T("Japanese Input for SHARP Brain"), WS_POPUP | WS_BORDER, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, NULL, NULL);
	SetWindowPos(g_hWnd, HWND_TOPMOST, GetSystemMetrics(SM_CXSCREEN) - 16 - GetSystemMetrics(SM_CXBORDER) * 2, GetSystemMetrics(SM_CYSCREEN) - 16 - GetSystemMetrics(SM_CYBORDER) * 2, 16 + GetSystemMetrics(SM_CXBORDER) * 2, 16 + GetSystemMetrics(SM_CYBORDER) * 2, 0);
	ShowWindow(g_hWnd, SW_SHOW);
	UpdateWindow(g_hWnd);
	RegisterIME();
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	UnregisterIME();
	UnregisterClass(Class.lpszClassName, Class.hInstance);
	UnloadFont();
	UnloadDictionary();
	return 0;
}

