#include "stdafx.h"
#include "kanji.h"

KANJI_PREFERENCE g_Preference;
KANJI_DICTIONARY* g_pDictionary;
DWORD g_dwDictionary;
DWORD g_dwMaxDictionary;
KANJI_DICTIONARY* g_pInputDictionary;
DWORD g_dwInputDictionary;
DWORD g_dwMaxInputDictionary;
KANJI_DICTIONARY g_TempDictionary[KANJI_MAX_WORD];
DWORD g_dwTempDictionary;
BOOL g_bTimeout;
DWORD g_StartTime;

void ResetTimeout()
{
	g_bTimeout = FALSE;
	g_StartTime = timeGetTime();
}

BOOL CheckTimeout()
{
	if(g_bTimeout)
		return FALSE;
	if(timeGetTime() - g_StartTime >= g_Preference.Timeout)
	{
		if(MessageBox(g_hWnd, _T("It will be a long time. Would you like to continue converting?"), _T(""), MB_YESNO) != IDYES)
		{
			g_bTimeout = TRUE;
			return FALSE;
		}
		ResetTimeout();
	}
	return TRUE;
}

LONG CompareBunsetsu(KANJI_BUNSETSU* p1, KANJI_BUNSETSU* p2)
{
	DWORD i;
	i = 0;
	while(p1->pKanji[i])
	{
		if(p1->pKanji[i] > p2->pKanji[i])
			return 1;
		else if(p1->pKanji[i] < p2->pKanji[i])
			return -1;
		i++;
	}
	return (LONG)_tcscmp(p1->Kana, p2->Kana);
};

DWORD FindKanjiHead(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* Kana, DWORD Count)
{
	DWORD Head;
	DWORD Tail;
	DWORD Mean;
	Head = 0;
	Tail = dwData;
	Mean = Tail / 2;
	while(Tail - Head > 1)
	{
		if(_tcsncmp(Kana, pData[Mean].Kana, Count) > 0)
		{
			Head = Mean;
			Mean = (Head + Tail) / 2;
		}
		else
		{
			Tail = Mean;
			Mean = (Head + Tail) / 2;
		}
	}
	if(_tcsncmp(Kana, pData[Mean].Kana, Count) > 0)
		Mean++;
	return Mean;
}

KANJI_DICTIONARY* FindKanji(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* Kana, DWORD Count, DWORD* pLastFound)
{
	DWORD i;
	if(*pLastFound == 0)
		i = FindKanjiHead(pData, dwData, Kana, Count);
	else
		i = *pLastFound;
	if(i < dwData)
	{
		if(memcmp(Kana, &pData[i].Kana, sizeof(TCHAR) * Count) == 0 && pData[i].Kana[Count] == _T('\0'))
		{
			*pLastFound = i;
			return &pData[i];
		}
	}
	return NULL;
}

LONG GetRelationPoint(KANJI_DICTIONARY* p1, KANJI_DICTIONARY* p2)
{
	LONG Point;
	TCHAR* pc1;
	TCHAR* pc2;
	BOOL b;
	Point = 0;
	pc1 = p1->Relation;
	while(*pc1 != _T('\0'))
	{
		pc2 = p2->Kanji;
		b = TRUE;
		while(*pc1 != _T('\n'))
		{
			if(*pc1 != *pc2)
				b = FALSE;
			pc1++;
			pc2++;
		}
		if(*pc2 != _T('\0'))
			b = FALSE;
		if(b)
			Point += g_Preference.PointRelation;
		pc1++;
	}
	return Point;
}

LONG GetSentenceRelationPoint(KANJI_DICTIONARY** pp, DWORD Count, BOOL bCheckBegin, BOOL bCheckEnd)
{
	DWORD i;
	DWORD j;
	LONG Point;
	DWORD JiritsugoCount;
	DWORD SuushiType;
	Point = 0;
	JiritsugoCount = 0;
	SuushiType = ULONG_MAX;
	if(Count > 0)
	{
		if(bCheckBegin)
		{
			if(pp[0]->Type & KANJI_TYPE_NOT_BEGIN)
				Point += g_Preference.PointNotBegin;
			if(!(pp[0]->Type & KANJI_TYPE_KUTOUTEN))
			{
				if(pp[0]->PrevType & KANJI_PREV_NEEDED)
					Point += g_Preference.PointMissPrev;
				if(pp[0]->PrevType & KANJI_PREV_PREFER_BEGIN)
					Point += g_Preference.PointPreferBegin;
			}
		}
		if(bCheckEnd)
		{
			if(pp[Count - 1]->Type & KANJI_TYPE_NOT_END)
				Point += g_Preference.PointNotEnd;
			if(!(pp[Count - 1]->Type & KANJI_TYPE_KUTOUTEN))
			{
				if(pp[Count - 1]->NextType & KANJI_NEXT_NEEDED)
					Point += g_Preference.PointMissNext;
				if(pp[Count - 1]->Type & ((KANJI_TYPE_YOUGEN | KANJI_TYPE_KATSUYOU) & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndYougen;
				if(pp[Count - 1]->Type & (KANJI_TYPE_FUZOKUGO & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndFuzokugo;
			}
		}
	}
	for(i = 0; i < Count; i++)
	{
		Point += pp[i]->Point;
		Point += g_Preference.PointMultipleWord;
		if((pp[i]->Type & (KANJI_TYPE_JIRITSUGO & KANJI_COMMON_MASK)) && !(pp[i]->Type & KANJI_TYPE_NO_COUNT))
		{
			JiritsugoCount++;
			Point += g_Preference.PointMultipleJiritsugo;
		}
		if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
		{
			if(SuushiType == ULONG_MAX)
				SuushiType = pp[i]->Type & KANJI_TYPE_SUUSHI_MASK;
			else if(!((pp[i]->Type & KANJI_TYPE_SUUSHI_MASK) & SuushiType))
				Point += g_Preference.PointDifferentSuushi;
		}
		if(i + 1 < Count)
		{
			if(!(pp[i]->Type & pp[i + 1]->PrevType) || !(pp[i]->NextType & pp[i + 1]->Type))
				Point += g_Preference.PointMismatch;
			if(pp[i]->Type & KANJI_TYPE_KUTOUTEN)
			{
				if(pp[i + 1]->Type & KANJI_TYPE_NOT_BEGIN)
					Point += g_Preference.PointNotBegin;
				if(pp[i + 1]->PrevType & KANJI_PREV_NEEDED)
					Point += g_Preference.PointMissPrev;
				if(pp[i + 1]->PrevType & KANJI_PREV_PREFER_BEGIN)
					Point += g_Preference.PointPreferBegin;
			}
			if(pp[i + 1]->Type & KANJI_TYPE_KUTOUTEN)
			{
				if(pp[i]->Type & KANJI_TYPE_NOT_END)
					Point += g_Preference.PointNotEnd;
				if(pp[i]->NextType & KANJI_NEXT_NEEDED)
					Point += g_Preference.PointMissNext;
				if(pp[i]->Type & ((KANJI_TYPE_YOUGEN | KANJI_TYPE_KATSUYOU) & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndYougen;
				if(pp[i]->Type & (KANJI_TYPE_FUZOKUGO & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndFuzokugo;
				if(pp[i]->NextType & KANJI_NEXT_PREFER_END)
					Point += g_Preference.PointPreferEnd;
			}
			else
			{
				if(pp[i + 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointMeishiJoshi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
						Point += g_Preference.PointKatsuyouMeishi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceKatsuyou;
					if(GetRelationPoint(pp[i], pp[i + 1]) > 0)
						Point += g_Preference.PointRelationKatsuyou;
					else
						Point += g_Preference.PointWrongKatsuyou;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceMeishi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
				{
					if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
						Point += g_Preference.PointSequenceJinmei;
					if(pp[i]->Type == KANJI_TYPE_SETTOUJI)
						Point += g_Preference.PointSettoujiJinmei;
				}
				if(pp[i + 1]->Type == KANJI_TYPE_SETSUBIJI)
				{
					if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
						Point += g_Preference.PointJinmeiSetsubiji;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceSuushi;
				}
			}
		}
		if(!(pp[i]->Type & KANJI_TYPE_NO_RELATION))
		{
			for(j = i + 1; j < Count; j++)
			{
				if(!(pp[j]->Type & KANJI_TYPE_NO_RELATION))
					Point += GetRelationPoint(pp[i], pp[j]) + GetRelationPoint(pp[j], pp[i]);
			}
		}
	}
	if(JiritsugoCount > 1)
	{
		if(bCheckEnd)
		{
			if(!(pp[Count - 1]->Type & KANJI_TYPE_KUTOUTEN))
			{
				if(pp[Count - 1]->NextType & KANJI_NEXT_PREFER_END)
					Point += g_Preference.PointPreferEnd;
			}
		}
	}
	return Point;
}

LONG GetSentenceRelationPoint(KANJI_DICTIONARY** pp, DWORD Count)
{
	return GetSentenceRelationPoint(pp, Count, TRUE, TRUE);
}

LONG CheckSentencePoint(KANJI_DICTIONARY** pp, DWORD Count)
{
	DWORD i;
	LONG Point;
	DWORD SuushiType;
	Point = 0;
	SuushiType = ULONG_MAX;
	if(Count > 0)
	{
		if(pp[0]->Type & KANJI_TYPE_NOT_BEGIN)
			Point += g_Preference.PointNotBegin;
		if(!(pp[0]->Type & KANJI_TYPE_KUTOUTEN))
		{
			if(pp[0]->PrevType & KANJI_PREV_NEEDED)
				Point += g_Preference.PointMissPrev;
			if(pp[0]->PrevType & KANJI_PREV_PREFER_BEGIN)
				Point += g_Preference.PointPreferBegin;
		}
	}
	for(i = 0; i < Count; i++)
	{
		Point += pp[i]->Point;
		Point += g_Preference.PointMultipleWord;
		if((pp[i]->Type & (KANJI_TYPE_JIRITSUGO & KANJI_COMMON_MASK)) && !(pp[i]->Type & KANJI_TYPE_NO_COUNT))
			Point += g_Preference.PointMultipleJiritsugo;
		if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
		{
			if(SuushiType == ULONG_MAX)
				SuushiType = pp[i]->Type & KANJI_TYPE_SUUSHI_MASK;
			else if(!((pp[i]->Type & KANJI_TYPE_SUUSHI_MASK) & SuushiType))
				Point += g_Preference.PointDifferentSuushi;
		}
		if(i + 1 < Count)
		{
			if(!(pp[i]->Type & pp[i + 1]->PrevType) || !(pp[i]->NextType & pp[i + 1]->Type))
				Point += g_Preference.PointMismatch;
			if(pp[i]->Type & KANJI_TYPE_KUTOUTEN)
			{
				if(pp[i + 1]->Type & KANJI_TYPE_NOT_BEGIN)
					Point += g_Preference.PointNotBegin;
				if(pp[i + 1]->PrevType & KANJI_PREV_NEEDED)
					Point += g_Preference.PointMissPrev;
				if(pp[i + 1]->PrevType & KANJI_PREV_PREFER_BEGIN)
					Point += g_Preference.PointPreferBegin;
			}
			if(pp[i + 1]->Type & KANJI_TYPE_KUTOUTEN)
			{
				if(pp[i]->Type & KANJI_TYPE_NOT_END)
					Point += g_Preference.PointNotEnd;
				if(pp[i]->NextType & KANJI_NEXT_NEEDED)
					Point += g_Preference.PointMissNext;
				if(pp[i]->Type & ((KANJI_TYPE_YOUGEN | KANJI_TYPE_KATSUYOU) & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndYougen;
				if(pp[i]->Type & (KANJI_TYPE_FUZOKUGO & KANJI_COMMON_MASK))
					Point += g_Preference.PointEndFuzokugo;
				if(pp[i]->NextType & KANJI_NEXT_PREFER_END)
					Point += g_Preference.PointPreferEnd;
			}
			else
			{
				if(pp[i + 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointMeishiJoshi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
						Point += g_Preference.PointKatsuyouMeishi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceKatsuyou;
					if(GetRelationPoint(pp[i], pp[i + 1]) > 0)
						Point += g_Preference.PointRelationKatsuyou;
					else
						Point += g_Preference.PointWrongKatsuyou;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceMeishi;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
				{
					if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
						Point += g_Preference.PointSequenceJinmei;
					if(pp[i]->Type == KANJI_TYPE_SETTOUJI)
						Point += g_Preference.PointSettoujiJinmei;
				}
				if(pp[i + 1]->Type == KANJI_TYPE_SETSUBIJI)
				{
					if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
						Point += g_Preference.PointJinmeiSetsubiji;
				}
				if(pp[i + 1]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
				{
					if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
						Point += g_Preference.PointSequenceSuushi;
				}
			}
		}
	}
	return Point;
}

LONG GetBunsetsuPoint(KANJI_DICTIONARY** pp, DWORD Count)
{
	DWORD i;
	LONG Point;
	DWORD SuushiType;
	Point = 0;
	SuushiType = ULONG_MAX;
	if(Count > 0)
	{
		if(pp[Count - 1]->Type & KANJI_TYPE_NOT_END)
			Point += g_Preference.PointNotEnd;
		if(!(pp[Count - 1]->Type & KANJI_TYPE_KUTOUTEN))
		{
			if(pp[Count - 1]->NextType & KANJI_NEXT_NEEDED)
				Point += g_Preference.PointMissNext;
		}
	}
	for(i = 0; i < Count; i++)
	{
		Point += pp[i]->Point;
		Point += g_Preference.PointMultipleWord;
		if((pp[i]->Type & (KANJI_TYPE_JIRITSUGO & KANJI_COMMON_MASK)) && !(pp[i]->Type & KANJI_TYPE_NO_COUNT))
			Point += g_Preference.PointMultipleJiritsugo;
		if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
		{
			if(SuushiType == ULONG_MAX)
				SuushiType = pp[i]->Type & KANJI_TYPE_SUUSHI_MASK;
			else if(!((pp[i]->Type & KANJI_TYPE_SUUSHI_MASK) & SuushiType))
				Point += g_Preference.PointDifferentSuushi;
		}
		if(i + 1 < Count)
		{
			if(!(pp[i]->Type & pp[i + 1]->PrevType) || !(pp[i]->NextType & pp[i + 1]->Type))
				Point += g_Preference.PointMismatch;
			if(pp[i + 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointMeishiJoshi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
					Point += g_Preference.PointKatsuyouMeishi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceKatsuyou;
				if(GetRelationPoint(pp[i], pp[i + 1]) > 0)
					Point += g_Preference.PointRelationKatsuyou;
				else
					Point += g_Preference.PointWrongKatsuyou;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceMeishi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
			{
				if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
					Point += g_Preference.PointSequenceJinmei;
				if(pp[i]->Type == KANJI_TYPE_SETTOUJI)
					Point += g_Preference.PointSettoujiJinmei;
			}
			if(pp[i + 1]->Type == KANJI_TYPE_SETSUBIJI)
			{
				if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
					Point += g_Preference.PointJinmeiSetsubiji;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceSuushi;
			}
		}
	}
	return Point;
}

LONG CheckBunsetsuPoint(KANJI_DICTIONARY** pp, DWORD Count)
{
	DWORD i;
	LONG Point;
	DWORD SuushiType;
	Point = 0;
	SuushiType = ULONG_MAX;
	for(i = 0; i < Count; i++)
	{
		Point += pp[i]->Point;
		Point += g_Preference.PointMultipleWord;
		if((pp[i]->Type & (KANJI_TYPE_JIRITSUGO & KANJI_COMMON_MASK)) && !(pp[i]->Type & KANJI_TYPE_NO_COUNT))
			Point += g_Preference.PointMultipleJiritsugo;
		if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
		{
			if(SuushiType == ULONG_MAX)
				SuushiType = pp[i]->Type & KANJI_TYPE_SUUSHI_MASK;
			else if(!((pp[i]->Type & KANJI_TYPE_SUUSHI_MASK) & SuushiType))
				Point += g_Preference.PointDifferentSuushi;
		}
		if(i + 1 < Count)
		{
			if(!(pp[i]->Type & pp[i + 1]->PrevType) || !(pp[i]->NextType & pp[i + 1]->Type))
				Point += g_Preference.PointMismatch;
			if(pp[i + 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointMeishiJoshi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
					Point += g_Preference.PointKatsuyouMeishi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_KATSUYOU & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceKatsuyou;
				if(GetRelationPoint(pp[i], pp[i + 1]) > 0)
					Point += g_Preference.PointRelationKatsuyou;
				else
					Point += g_Preference.PointWrongKatsuyou;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceMeishi;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
			{
				if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
					Point += g_Preference.PointSequenceJinmei;
				if(pp[i]->Type == KANJI_TYPE_SETTOUJI)
					Point += g_Preference.PointSettoujiJinmei;
			}
			if(pp[i + 1]->Type == KANJI_TYPE_SETSUBIJI)
			{
				if(pp[i]->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
					Point += g_Preference.PointJinmeiSetsubiji;
			}
			if(pp[i + 1]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
			{
				if(pp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK))
					Point += g_Preference.PointSequenceSuushi;
			}
		}
	}
	return Point;
}

DWORD GetLongestBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, BOOL bJoshi, LONG Threshold)
{
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_WORD];
	DWORD LastFound[KANJI_MAX_WORD];
	DWORD KanaCount;
	DWORD ResultPosition;
	DWORD ResultCount;
	BOOL bSuushi;
	BOOL bNoCount;
	DWORD i;
	pResult->pKanji[0] = NULL;
	pResult->Kana[0] = _T('\0');
	Position[0] = 0;
	LastFound[0] = 0;
	KanaCount = KANJI_MAX_KANA - 1;
	ResultPosition = 0;
	ResultCount = 0;
	if(Count == 0)
		return ResultPosition;
	i = 0;
	while(true)
	{
		if(i == KANJI_MAX_WORD - 1)
		{
			i--;
			KanaCount = Position[i + 1] - Position[i];
		}
		if(Position[i] + KanaCount <= Count && (pTemp[i] = FindKanji(pData, dwData, pString + Position[i], KanaCount, &LastFound[i])))
		{
			if(i == 0 && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if(i == 1 && bNoCount && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if((i > 0 && !bNoCount) || i > 1)
			{
				if(bSuushi)
				{
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI | KANJI_TYPE_SUUSHI) & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI) & KANJI_COMMON_MASK)) && (pTemp[i - 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
				else
				{
					if(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO)
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
			}
			if(i > 0 && (pTemp[i - 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)) && !(pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
			{
				LastFound[i]++;
				continue;
			}
			if(CheckBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i + 1) < Threshold)
			{
				LastFound[i]++;
				continue;
			}
			if(i == 0)
			{
				if(pTemp[i]->Type & KANJI_TYPE_NO_COUNT)
					bNoCount = TRUE;
				else
					bNoCount = FALSE;
			}
			if((i == 0 && !bNoCount) || (i == 1 && bNoCount))
			{
				if((pTemp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK)) && !(pTemp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					bSuushi = TRUE;
				else
					bSuushi = FALSE;
			}
			LastFound[i]++;
			Position[i + 1] = Position[i] + KanaCount;
			LastFound[i + 1] = 0;
			KanaCount = KANJI_MAX_KANA - 1;
			i++;
			if(Position[i] > ResultPosition)
			{
				if(GetBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i) >= Threshold)
				{
					memcpy(&pResult->pKanji, &pTemp, sizeof(KANJI_DICTIONARY*) * i);
					pResult->pKanji[i] = NULL;
					memcpy(&pResult->Kana, pString, sizeof(TCHAR) * Position[i]);
					pResult->Kana[Position[i]] = _T('\0');
					ResultPosition = Position[i];
					ResultCount = i;
				}
			}
		}
		else
		{
			LastFound[i] = 0;
			KanaCount--;
			if(KanaCount == 0)
			{
				if(i == 0)
					break;
				i--;
				KanaCount = Position[i + 1] - Position[i];
			}
		}
	}
	return ResultPosition;
}

DWORD EnumBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, DWORD dwResult, BOOL bJoshi, LONG Threshold)
{
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_WORD];
	DWORD LastFound[KANJI_MAX_WORD];
	DWORD KanaCount;
	DWORD ResultCount;
	BOOL bSuushi;
	BOOL bNoCount;
	DWORD i;
	if(pResult)
	{
		pResult[0].pKanji[0] = NULL;
		pResult[0].Kana[0] = _T('\0');
	}
	Position[0] = 0;
	LastFound[0] = 0;
	KanaCount = KANJI_MAX_KANA - 1;
	ResultCount = 0;
	if(Count == 0)
		return ResultCount;
	i = 0;
	while(true)
	{
		if(i == KANJI_MAX_WORD - 1)
		{
			i--;
			KanaCount = Position[i + 1] - Position[i];
		}
		if(Position[i] + KanaCount <= Count && (pTemp[i] = FindKanji(pData, dwData, pString + Position[i], KanaCount, &LastFound[i])))
		{
			if(i == 0 && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if(i == 1 && bNoCount && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if((i > 0 && !bNoCount) || i > 1)
			{
				if(bSuushi)
				{
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI | KANJI_TYPE_SUUSHI) & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI) & KANJI_COMMON_MASK)) && (pTemp[i - 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
				else
				{
					if(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO)
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
			}
			if(CheckBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i + 1) < Threshold)
			{
				LastFound[i]++;
				continue;
			}
			if(i > 0 && (pTemp[i - 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)) && !(pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
			{
				LastFound[i]++;
				continue;
			}
			if(i == 0)
			{
				if(pTemp[i]->Type & KANJI_TYPE_NO_COUNT)
					bNoCount = TRUE;
				else
					bNoCount = FALSE;
			}
			if((i == 0 && !bNoCount) || (i == 1 && bNoCount))
			{
				if((pTemp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK)) && !(pTemp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					bSuushi = TRUE;
				else
					bSuushi = FALSE;
			}
			LastFound[i]++;
			Position[i + 1] = Position[i] + KanaCount;
			LastFound[i + 1] = 0;
			KanaCount = KANJI_MAX_KANA - 1;
			i++;
			if(Position[i] >= Count)
			{
				if(GetBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i) >= Threshold)
				{
					if(pResult)
					{
						if(ResultCount < dwResult - 1)
						{
							memcpy(&pResult[ResultCount].pKanji, &pTemp, sizeof(KANJI_DICTIONARY*) * i);
							pResult[ResultCount].pKanji[i] = NULL;
							memcpy(&pResult[ResultCount].Kana, pString, sizeof(TCHAR) * Position[i]);
							pResult[ResultCount].Kana[Position[i]] = _T('\0');
						}
						else
							break;
					}
					ResultCount++;
				}
				i--;
				KanaCount = Position[i + 1] - Position[i];
			}
		}
		else
		{
			LastFound[i] = 0;
			KanaCount--;
			if(KanaCount == 0)
			{
				if(i == 0)
					break;
				i--;
				KanaCount = Position[i + 1] - Position[i];
			}
		}
	}
	if(pResult)
	{
		pResult[ResultCount].pKanji[0] = NULL;
		pResult[ResultCount].Kana[0] = _T('\0');
	}
	return ResultCount;
}

BOOL GetFirstBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, BOOL bJoshi, LONG Threshold)
{
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_WORD];
	DWORD LastFound[KANJI_MAX_WORD];
	DWORD KanaCount;
	BOOL bSuushi;
	BOOL bNoCount;
	DWORD i;
	if(pResult)
	{
		pResult->pKanji[0] = NULL;
		pResult->Kana[0] = _T('\0');
	}
	Position[0] = 0;
	LastFound[0] = 0;
	KanaCount = KANJI_MAX_KANA - 1;
	if(Count == 0)
		return FALSE;
	i = 0;
	while(true)
	{
		if(i == KANJI_MAX_WORD - 1)
		{
			i--;
			KanaCount = Position[i + 1] - Position[i];
		}
		if(Position[i] + KanaCount <= Count && (pTemp[i] = FindKanji(pData, dwData, pString + Position[i], KanaCount, &LastFound[i])))
		{
			if(i == 0 && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if(i == 1 && bNoCount && !(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO))
			{
				LastFound[i]++;
				continue;
			}
			if((i > 0 && !bNoCount) || i > 1)
			{
				if(bSuushi)
				{
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI | KANJI_TYPE_SUUSHI) & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!(pTemp[i]->Type & ((KANJI_TYPE_JOSHI | KANJI_TYPE_SETSUBIJI) & KANJI_COMMON_MASK)) && (pTemp[i - 1]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
				else
				{
					if(pTemp[i]->Type & KANJI_TYPE_JIRITSUGO)
					{
						LastFound[i]++;
						continue;
					}
					if(!bJoshi && (pTemp[i]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK)))
					{
						LastFound[i]++;
						continue;
					}
				}
			}
			if(CheckBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i + 1) < Threshold)
			{
				LastFound[i]++;
				continue;
			}
			if(i == 0)
			{
				if(pTemp[i]->Type & KANJI_TYPE_NO_COUNT)
					bNoCount = TRUE;
				else
					bNoCount = FALSE;
			}
			if((i == 0 && !bNoCount) || (i == 1 && bNoCount))
			{
				if((pTemp[i]->Type & (KANJI_TYPE_SUUSHI & KANJI_COMMON_MASK)) && !(pTemp[i]->Type & (KANJI_TYPE_MEISHI & KANJI_COMMON_MASK)))
					bSuushi = TRUE;
				else
					bSuushi = FALSE;
			}
			LastFound[i]++;
			Position[i + 1] = Position[i] + KanaCount;
			LastFound[i + 1] = 0;
			KanaCount = KANJI_MAX_KANA - 1;
			i++;
			if(Position[i] >= Count)
			{
				if(GetBunsetsuPoint((KANJI_DICTIONARY**)&pTemp, i) >= Threshold)
				{
					if(pResult)
					{
						memcpy(&pResult->pKanji, &pTemp, sizeof(KANJI_DICTIONARY*) * i);
						pResult->pKanji[i] = NULL;
						memcpy(&pResult->Kana, pString, sizeof(TCHAR) * Position[i]);
						pResult->Kana[Position[i]] = _T('\0');
					}
					return TRUE;
				}
				i--;
				KanaCount = Position[i + 1] - Position[i];
			}
			else
			{
				if(pTemp[i - 1]->Type & (KANJI_TYPE_JOSHI & KANJI_COMMON_MASK))
				{
					i--;
					KanaCount = Position[i + 1] - Position[i];
				}
			}
		}
		else
		{
			LastFound[i] = 0;
			KanaCount--;
			if(KanaCount == 0)
			{
				if(i == 0)
					break;
				i--;
				KanaCount = Position[i + 1] - Position[i];
			}
		}
	}
	return FALSE;
}

DWORD GetKanjiFromBunsetsu(KANJI_BUNSETSU* pResult, KANJI_DICTIONARY** ppResult)
{
	DWORD i;
	DWORD j;
	i = 0;
	j = 0;
	while(pResult->pKanji[0])
	{
		if(pResult->pKanji[i])
		{
			ppResult[j] = pResult->pKanji[i];
			i++;
			j++;
		}
		else
		{
			pResult++;
			i = 0;
		}
	}
	ppResult[j] = NULL;
	return j;
}

LONG GetBunsetsuRelationPoint(KANJI_BUNSETSU* p, DWORD Count, BOOL bCheckBegin, BOOL bCheckEnd)
{
	KANJI_DICTIONARY* pOld;
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	LONG Point;
	DWORD i;
	pOld = p[Count].pKanji[0];
	p[Count].pKanji[0] = NULL;
	i = GetKanjiFromBunsetsu(p, (KANJI_DICTIONARY**)&pTemp);
	Point = GetSentenceRelationPoint(pTemp, i, bCheckBegin, bCheckEnd);
	p[Count].pKanji[0] = pOld;
	return Point;
}

LONG CheckBunsetsuRelationPoint(KANJI_BUNSETSU* p, DWORD Count)
{
	KANJI_DICTIONARY* pOld;
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	LONG Point;
	DWORD i;
	pOld = p[Count].pKanji[0];
	p[Count].pKanji[0] = NULL;
	i = GetKanjiFromBunsetsu(p, (KANJI_DICTIONARY**)&pTemp);
	Point = CheckSentencePoint(pTemp, i);
	p[Count].pKanji[0] = pOld;
	return Point;
}

LONG CheckProofKanaToBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, KANJI_BUNSETSU* pResult, LONG Threshold)
{
	KANJI_BUNSETSU Temp[64];
	DWORD TempPosition[KANJI_MAX_BUNSETSU];
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_BUNSETSU];
	DWORD MaxCount;
	DWORD ProofCount;
	LONG ResultPoint;
	LONG Point;
	DWORD JobCount;
	DWORD i;
	DWORD j;
	DWORD k;
	DWORD l;
	TempPosition[0] = 0;
	Position[0] = 0;
	ResultPoint = LONG_MIN;
	JobCount = 0;
	i = 0;
	while(pResult[i].pKanji[0])
	{
		i++;
	}
	MaxCount = i;
	ProofCount = g_Preference.MaxProofCount / i;
	for(i = 0; i < MaxCount; i++)
		TempPosition[i + 1] = TempPosition[i] + EnumBunsetsu(pData, dwData, pResult[i].Kana, (DWORD)_tcslen(pResult[i].Kana), (KANJI_BUNSETSU*)&Temp[TempPosition[i]], ProofCount + 1, TRUE, Threshold) + 1;
	pResult[MaxCount].pKanji[0] = NULL;
	pResult[MaxCount].Kana[0] = _T('\0');
	i = 0;
	while(true)
	{
		if(Temp[Position[i]].pKanji[0])
		{
			if(i == MaxCount - 1)
			{
				if(JobCount >= g_Preference.TimeoutCount)
				{
					if(!CheckTimeout())
						return ResultPoint;
					JobCount = 0;
				}
				JobCount++;
				i++;
				k = 0;
				l = 0;
				for(j = 0; j < i; j++)
				{
					k = 0;
					while(Temp[Position[j]].pKanji[k])
					{
						pTemp[l] = Temp[Position[j]].pKanji[k];
						k++;
						l++;
					}
				}
				Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, l);
				if(Point > ResultPoint)
				{
					for(j = 0; j < i; j++)
						pResult[j] = Temp[Position[j]];
					ResultPoint = Point;
				}
				i--;
				Position[i]++;
			}
			else
			{
				Position[i + 1] = TempPosition[i + 1];
				i++;
			}
		}
		else
		{
			if(i == 0)
				break;
			i--;
			Position[i]++;
		}
	}
	return ResultPoint;
}

LONG ConvertKanaToBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, LONG Threshold)
{
	KANJI_BUNSETSU Temp[2][KANJI_MAX_BUNSETSU];
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_WORD];
	LONG ResultPoint;
	LONG Point;
	DWORD JobCount;
	DWORD i;
	DWORD j;
	pResult[0].pKanji[0] = NULL;
	pResult[0].Kana[0] = _T('\0');
	Temp[0][0].pKanji[0] = NULL;
	Position[0] = 0;
	ResultPoint = LONG_MIN;
	JobCount = 0;
	i = 0;
	while(true)
	{
		if(Position[i] >= Count)
		{
			if(JobCount >= g_Preference.TimeoutCount)
			{
				if(!CheckTimeout())
					return ResultPoint;
				JobCount = 0;
			}
			JobCount++;
			memcpy(&Temp[1], &Temp[0], sizeof(KANJI_BUNSETSU) * i);
			Temp[1][i].pKanji[0] = NULL;
			Temp[1][i].Kana[0] = _T('\0');
			CheckProofKanaToBunsetsu(pData, dwData, (KANJI_BUNSETSU*)&Temp[1], Threshold);
			j = GetKanjiFromBunsetsu((KANJI_BUNSETSU*)&Temp[1], (KANJI_DICTIONARY**)&pTemp);
			Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, j);
			if(Point > ResultPoint)
			{
				memcpy(pResult, &Temp[1], sizeof(KANJI_BUNSETSU) * i);
				pResult[i].pKanji[0] = NULL;
				pResult[i].Kana[0] = _T('\0');
				ResultPoint = Point;
			}
			i--;
		}
		else
		{
			j = 0;
			while(Temp[0][i].pKanji[j])
			{
				j++;
			}
			if(j > 0)
			{
				if((Temp[0][i].pKanji[0]->Type & KANJI_TYPE_NO_COUNT) || (Temp[0][i].pKanji[j - 1]->Type & ((KANJI_TYPE_FUZOKUGO | KANJI_TYPE_SAHENDOUSHI | KANJI_TYPE_ZAHENDOUSHI) & KANJI_COMMON_MASK)))
					Position[i + 1] = Position[i] + GetLongestBunsetsu(pData, dwData, pString + Position[i], Position[i + 1] - Position[i] - 1, &Temp[0][i], TRUE, Threshold);
				else
					Position[i + 1] = 0;
			}
			else
				Position[i + 1] = Position[i] + GetLongestBunsetsu(pData, dwData, pString + Position[i], Count - Position[i], &Temp[0][i], TRUE, Threshold);
			if(Position[i + 1] > Position[i])
			{
				Temp[0][i + 1].pKanji[0] = NULL;
				i++;
			}
			else
			{
				if(i == 0)
					break;
				i--;
			}
		}
	}
	return ResultPoint;
}

LONG ConvertKanaToBunsetsu2Longest(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, LONG Threshold)
{
	KANJI_BUNSETSU Temp[KANJI_MAX_BUNSETSU];
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_WORD];
	LONG ResultPoint;
	LONG Point;
	DWORD i;
	DWORD j;
	DWORD k;
	DWORD l;
	pResult[0].pKanji[0] = NULL;
	pResult[0].Kana[0] = _T('\0');
	Temp[0].pKanji[0] = NULL;
	Position[0] = 0;
	ResultPoint = LONG_MIN;
	i = 0;
	while(true)
	{
		j = 1;
		l = 0;
		while(j < KANJI_MAX_KANA && j <= Count - Position[i])
		{
			if(!GetFirstBunsetsu(pData, dwData, pString + Position[i], j, NULL, TRUE, Threshold))
			{
				j++;
				continue;
			}
			k = 1;
			while(k < KANJI_MAX_KANA && j + k <= Count - Position[i])
			{
				if(!GetFirstBunsetsu(pData, dwData, pString + Position[i] + j, k, NULL, TRUE, Threshold))
				{
					k++;
					continue;
				}
				if(j + k > l)
				{
					l = j + k;
					Position[i + 1] = Position[i] + j;
				}
				k++;
			}
			j++;
		}
		if(l == 0)
		{
			memcpy(pResult, &Temp, sizeof(KANJI_BUNSETSU) * i);
			pResult[i].pKanji[0] = NULL;
			pResult[i].Kana[0] = _T('\0');
			break;
		}
		GetFirstBunsetsu(pData, dwData, pString + Position[i], Position[i + 1] - Position[i], &Temp[i], TRUE, Threshold);
		i++;
		if(l == Count - Position[i - 1])
		{
			GetFirstBunsetsu(pData, dwData, pString + Position[i], Count - Position[i], &Temp[i], TRUE, Threshold);
			i++;
			Temp[i].pKanji[0] = NULL;
			Temp[i].Kana[0] = _T('\0');
			CheckProofKanaToBunsetsu(pData, dwData, (KANJI_BUNSETSU*)&Temp, Threshold);
			j = GetKanjiFromBunsetsu((KANJI_BUNSETSU*)&Temp, (KANJI_DICTIONARY**)&pTemp);
			Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, j);
			if(Point > ResultPoint)
			{
				memcpy(pResult, &Temp, sizeof(KANJI_BUNSETSU) * i);
				pResult[i].pKanji[0] = NULL;
				pResult[i].Kana[0] = _T('\0');
				ResultPoint = Point;
			}
			break;
		}
	}
	return ResultPoint;
}

LONG ConvertKanaToBunsetsuHighest(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult, LONG Threshold)
{
	KANJI_BUNSETSU Temp[KANJI_MAX_BUNSETSU + KANJI_MAX_HIGHEST_BUNSETSU - 1];
	KANJI_BUNSETSU Enum[KANJI_MAX_HIGHEST_BUNSETSU][KANJI_MAX_HIGHEST_ENUM];
	KANJI_BUNSETSU Bunsetsu;
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD Position[KANJI_MAX_HIGHEST_BUNSETSU];
	DWORD MaxCount[KANJI_MAX_HIGHEST_BUNSETSU];
	DWORD EnumPosition[KANJI_MAX_HIGHEST_BUNSETSU];
	DWORD KanaCount;
	LONG ResultPoint;
	LONG BunsetsuPoint;
	LONG Point;
	DWORD JobCount;
	DWORD i;
	DWORD j;
	DWORD k;
	DWORD l;
	DWORD m;
	for(i = 0; i < KANJI_MAX_HIGHEST_BUNSETSU - 1; i++)
	{
		Temp[i].pKanji[0] = NULL;
	}
	Position[0] = 0;
	ResultPoint = LONG_MIN;
	JobCount = 0;
	i = 0;
	while(Position[0] < Count)
	{
		KanaCount = 1;
		MaxCount[0] = GetLongestBunsetsu(pData, dwData, pString + Position[0], Count - Position[0], &Enum[0][0], TRUE, Threshold);
		if(MaxCount[0] == 0)
			return LONG_MIN;
		EnumPosition[0] = 0;
		EnumBunsetsu(pData, dwData, pString + Position[0], KanaCount, (KANJI_BUNSETSU*)&Enum[0], KANJI_MAX_HIGHEST_ENUM, TRUE, Threshold);
		Bunsetsu.pKanji[0] = NULL;
		Bunsetsu.Kana[0] = _T('\0');
		BunsetsuPoint = LONG_MIN;
		j = 0;
		while(true)
		{
			if(Enum[j][EnumPosition[j]].pKanji[0])
			{
				if(j > 0)
				{
					if((Enum[j - 1][EnumPosition[j - 1]].pKanji[0]->Type & KANJI_TYPE_SUUSHI) && (Enum[j][EnumPosition[j]].pKanji[0]->Type & KANJI_TYPE_SUUSHI))
					{
						EnumPosition[j]++;
						continue;
					}
				}
				if(Position[j] + KanaCount >= Count || j >= KANJI_MAX_HIGHEST_BUNSETSU - 1)
				{
					if(JobCount >= g_Preference.TimeoutCount)
					{
						if(!CheckTimeout())
							return ResultPoint;
						JobCount = 0;
					}
					JobCount++;
					for(k = 0; k < j + 1; k++)
						Temp[i + k + KANJI_MAX_HIGHEST_BUNSETSU - 1] = Enum[k][EnumPosition[k]];
					k = 0;
					for(l = i; l < i + j + KANJI_MAX_HIGHEST_BUNSETSU; l++)
					{
						m = 0;
						while(Temp[l].pKanji[m])
						{
							pTemp[k] = Temp[l].pKanji[m];
							k++;
							m++;
						}
					}
					if(i < KANJI_MAX_HIGHEST_BUNSETSU)
					{
						if(Position[j] + KanaCount >= Count)
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, TRUE, TRUE);
						else
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, TRUE, FALSE);
					}
					else
					{
						if(Position[j] + KanaCount >= Count)
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, FALSE, TRUE);
						else
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, FALSE, FALSE);
					}
					Point += (Position[j] + KanaCount - Position[0]) * g_Preference.PointMultipleChar;
					Point += j * g_Preference.PointMultipleBunsetsu;
					if(Point > BunsetsuPoint)
					{
						Bunsetsu = Temp[i + KANJI_MAX_HIGHEST_BUNSETSU - 1];
						BunsetsuPoint = Point;
					}
					EnumPosition[j]++;
				}
				else
				{
					Position[j + 1] = Position[j] + KanaCount;
					KanaCount = 1;
					j++;
					MaxCount[j] = GetLongestBunsetsu(pData, dwData, pString + Position[j], Count - Position[j], &Enum[j][0], TRUE, Threshold);
					EnumPosition[j] = 0;
					EnumBunsetsu(pData, dwData, pString + Position[j], KanaCount, (KANJI_BUNSETSU*)&Enum[j], KANJI_MAX_HIGHEST_ENUM, TRUE, Threshold);
				}
			}
			else
			{
				KanaCount++;
				if(KanaCount > MaxCount[j] || Position[j] + KanaCount > Count)
				{
					if(j == 0)
						break;
					else
					{
						j--;
						KanaCount = Position[j + 1] - Position[j];
						EnumPosition[j]++;
					}
				}
				else
				{
					EnumPosition[j] = 0;
					EnumBunsetsu(pData, dwData, pString + Position[j], KanaCount, (KANJI_BUNSETSU*)&Enum[j], KANJI_MAX_HIGHEST_ENUM, TRUE, Threshold);
				}
			}
		}
		pResult[i] = Bunsetsu;
		Temp[i + KANJI_MAX_HIGHEST_BUNSETSU - 1] = Bunsetsu;
		i++;
		Position[0] = Position[0] + (DWORD)_tcslen(Bunsetsu.Kana);
	}
	pResult[i].pKanji[0] = NULL;
	pResult[i].Kana[0] = _T('\0');
//	return ResultPoint;
	return 0;
}

void ConvertKanaToBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, KANJI_BUNSETSU* pResult)
{
/*	KANJI_BUNSETSU Temp[2][KANJI_MAX_BUNSETSU];
	LONG Point[2];
	Point[0] = ConvertKanaToBunsetsu(pData, dwData, pString, Count, (KANJI_BUNSETSU*)&Temp[0], g_Preference.PointThreshold1);
	Point[1] = ConvertKanaToBunsetsu2Longest(pData, dwData, pString, Count, (KANJI_BUNSETSU*)&Temp[1], g_Preference.PointThreshold1);
	if(Point[0] < g_Preference.PointThreshold1 && Point[1] < g_Preference.PointThreshold1)
	{
		Point[0] = ConvertKanaToBunsetsu(pData, dwData, pString, Count, (KANJI_BUNSETSU*)&Temp[0], g_Preference.PointThreshold2);
		Point[1] = ConvertKanaToBunsetsu2Longest(pData, dwData, pString, Count, (KANJI_BUNSETSU*)&Temp[1], g_Preference.PointThreshold2);
	}
	if(Point[0] > Point[1])
		GetKanjiFromBunsetsu((KANJI_BUNSETSU*)&Temp[0], ppResult);
	else
		GetKanjiFromBunsetsu((KANJI_BUNSETSU*)&Temp[1], ppResult);*/
	ConvertKanaToBunsetsuHighest(pData, dwData, pString, Count, pResult, g_Preference.PointThreshold2);
}

DWORD EnumTempBunsetsu(TCHAR* Kana, KANJI_BUNSETSU* pResult, DWORD dwResult)
{
	DWORD i;
	KANJI_DICTIONARY Temp[2];
	TCHAR* p;
	DWORD ResultCount;
	Temp[0].Type = KANJI_TYPE_DEFAULT;
	Temp[0].PrevType = KANJI_PREV_DEFAULT;
	Temp[0].NextType = KANJI_NEXT_DEFAULT;
	Temp[0].Point = g_Preference.PointDefaultLearning;
	_tcscpy(Temp[0].Kana, Kana);
	_tcscpy(Temp[0].Kanji, Kana);
	p = Temp[0].Kanji;
	while(*p != _T('\0'))
	{
		if(*p >= 0x3041 && *p <= 0x3094)
			*p += 0x0060;
		p++;
	}
	_tcscpy(Temp[0].Relation, _T(""));
	Temp[1].Type = KANJI_TYPE_DEFAULT;
	Temp[1].PrevType = KANJI_PREV_DEFAULT;
	Temp[1].NextType = KANJI_NEXT_DEFAULT;
	Temp[1].Point = g_Preference.PointDefaultLearning;
	_tcscpy(Temp[1].Kana, Kana);
	_tcscpy(Temp[1].Kanji, Kana);
	_tcscpy(Temp[1].Relation, _T(""));
	i = 0;
	while(i < g_dwTempDictionary)
	{
		if(_tcscmp(g_TempDictionary[i].Kana, Temp[0].Kana) == 0 && _tcscmp(g_TempDictionary[i].Kanji, Temp[0].Kanji) == 0)
			break;
		i++;
	}
	if(i == g_dwTempDictionary)
	{
		g_TempDictionary[g_dwTempDictionary] = Temp[0];
		g_dwTempDictionary++;
	}
	i = 0;
	while(i < g_dwTempDictionary)
	{
		if(_tcscmp(g_TempDictionary[i].Kana, Temp[1].Kana) == 0 && _tcscmp(g_TempDictionary[i].Kanji, Temp[1].Kanji) == 0)
			break;
		i++;
	}
	if(i == g_dwTempDictionary)
	{
		g_TempDictionary[g_dwTempDictionary] = Temp[1];
		g_dwTempDictionary++;
	}
	ResultCount = 0;
	i = 0;
	while(i < g_dwTempDictionary)
	{
		if(_tcscmp(g_TempDictionary[i].Kana, Kana) == 0)
		{
			if(ResultCount < dwResult - 1)
			{
				pResult[ResultCount].pKanji[0] = &g_TempDictionary[i];
				pResult[ResultCount].pKanji[1] = NULL;
				_tcscpy(pResult[ResultCount].Kana, g_TempDictionary[i].Kana);
				ResultCount++;
			}
			else
				break;
		}
		i++;
	}
	if(pResult)
	{
		pResult[ResultCount].pKanji[0] = NULL;
		pResult[ResultCount].Kana[0] = _T('\0');
	}
	return ResultCount;
}

LONG CheckProofKanaToBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, KANJI_BUNSETSU* pResult, LONG Threshold)
{
	KANJI_BUNSETSU Temp[KANJI_MAX_BUNSETSU + KANJI_MAX_HIGHEST_BUNSETSU - 1];
	TCHAR* Kana[KANJI_MAX_WORD];
	KANJI_BUNSETSU Enum[KANJI_MAX_HIGHEST_BUNSETSU][KANJI_MAX_PROOF];
	KANJI_BUNSETSU Bunsetsu;
	KANJI_DICTIONARY* pTemp[KANJI_MAX_WORD];
	DWORD EnumPosition[KANJI_MAX_HIGHEST_BUNSETSU];
	LONG ResultPoint;
	LONG BunsetsuPoint;
	LONG Point;
	DWORD TempCount;
	DWORD i;
	DWORD j;
	DWORD k;
	DWORD l;
	DWORD m;
	for(i = 0; i < KANJI_MAX_HIGHEST_BUNSETSU - 1; i++)
	{
		Temp[i].pKanji[0] = NULL;
	}
	i = 0;
	while(*pString != _T('\0'))
	{
		Kana[i] = pString;
		pString += _tcslen(pString) + 1;
		i++;
	}
	Kana[i] = pString;
	ResultPoint = LONG_MIN;
	TempCount = 0;
	i = 0;
	while(Kana[i][0] != _T('\0'))
	{
		EnumPosition[0] = 0;
		EnumBunsetsu(pData, dwData, Kana[i], (DWORD)_tcslen(Kana[i]), (KANJI_BUNSETSU*)&Enum[0], KANJI_MAX_PROOF, TRUE, Threshold);
		if(!Enum[0][0].pKanji[0])
			EnumTempBunsetsu(Kana[i], (KANJI_BUNSETSU*)&Enum[0], KANJI_MAX_PROOF);
		Bunsetsu.pKanji[0] = NULL;
		Bunsetsu.Kana[0] = _T('\0');
		BunsetsuPoint = LONG_MIN;
		j = 0;
		while(true)
		{
			if(EnumPosition[j] == 0 || (Enum[j][0].pKanji[0] && Enum[j][EnumPosition[j]].pKanji[0]))
			{
				if(Kana[i + j + 1][0] == _T('\0') || j >= KANJI_MAX_HIGHEST_BUNSETSU - 1)
				{
					for(k = 0; k < j + 1; k++)
						Temp[i + k + KANJI_MAX_HIGHEST_BUNSETSU - 1] = Enum[k][EnumPosition[k]];
					k = 0;
					for(l = i; l < i + j + KANJI_MAX_HIGHEST_BUNSETSU; l++)
					{
						m = 0;
						while(Temp[l].pKanji[m])
						{
							pTemp[k] = Temp[l].pKanji[m];
							k++;
							m++;
						}
					}
					if(i < KANJI_MAX_HIGHEST_BUNSETSU)
					{
						if(Kana[i + j + 1][0] == _T('\0'))
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, TRUE, TRUE);
						else
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, TRUE, FALSE);
					}
					else
					{
						if(Kana[i + j + 1][0] == _T('\0'))
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, FALSE, TRUE);
						else
							Point = GetSentenceRelationPoint((KANJI_DICTIONARY**)&pTemp, k, FALSE, FALSE);
					}
					if(Point > BunsetsuPoint)
					{
						Bunsetsu = Temp[i + KANJI_MAX_HIGHEST_BUNSETSU - 1];
						BunsetsuPoint = Point;
					}
					EnumPosition[j]++;
				}
				else
				{
					j++;
					EnumPosition[j] = 0;
					EnumBunsetsu(pData, dwData, Kana[i + j], (DWORD)_tcslen(Kana[i + j]), (KANJI_BUNSETSU*)&Enum[j], KANJI_MAX_PROOF, TRUE, Threshold);
				}
			}
			else
			{
				if(j == 0)
					break;
				else
				{
					j--;
					EnumPosition[j]++;
				}
			}
		}
		pResult[i] = Bunsetsu;
		Temp[i + KANJI_MAX_HIGHEST_BUNSETSU - 1] = Bunsetsu;
		i++;
	}
	pResult[i].pKanji[0] = NULL;
	pResult[i].Kana[0] = _T('\0');
//	return ResultPoint;
	return 0;
}

void ProofKanaToBunsetsu(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, KANJI_BUNSETSU* pResult)
{
	if(CheckProofKanaToBunsetsu(pData, dwData, pString, pResult, g_Preference.PointThreshold1) < g_Preference.PointThreshold1)
	{
		if(CheckProofKanaToBunsetsu(pData, dwData, pString, pResult, g_Preference.PointThreshold2) < g_Preference.PointThreshold2)
			CheckProofKanaToBunsetsu(pData, dwData, pString, pResult, LONG_MIN);
	}
}

void GetKana(KANJI_DICTIONARY** ppResult, TCHAR* pString)
{
	DWORD i;
	i = 0;
	while(ppResult[i])
	{
		_tcscpy(pString, ppResult[i]->Kana);
		pString += _tcslen(ppResult[i]->Kana) + 1;
		i++;
	}
	*pString = _T('\0');
}

void GetKanaFromBunsetsu(KANJI_BUNSETSU* pResult, TCHAR* pString)
{
	DWORD i;
	i = 0;
	while(pResult[i].pKanji[0])
	{
		_tcscpy(pString, pResult[i].Kana);
		pString += _tcslen(pResult[i].Kana) + 1;
		i++;
	}
	*pString = _T('\0');
}

void ConvertInputToKana(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, DWORD Count, TCHAR* pOutput)
{
	KANJI_DICTIONARY* pTemp;
	DWORD Position;
	DWORD InputCount;
	DWORD i;
	TCHAR* p;
	Position = 0;
	InputCount = KANJI_MAX_KANA - 1;
	while(Position < Count)
	{
		if(Position + InputCount <= Count)
		{
			i = 0;
			if(pTemp = FindKanji(pData, dwData, pString + Position, InputCount, &i))
			{
				p = pTemp->Kanji;
				while(*p != _T('\0'))
				{
					*pOutput = *p;
					pOutput++;
					p++;
				}
				Position += InputCount;
				InputCount = KANJI_MAX_KANA - 1;
			}
			else
			{
				InputCount--;
				if(InputCount == 0)
				{
					*pOutput = pString[Position];
					pOutput++;
					Position++;
					InputCount = KANJI_MAX_KANA - 1;
				}
			}
		}
		else
		{
			InputCount--;
			if(InputCount == 0)
			{
				*pOutput = pString[Position];
				pOutput++;
				Position++;
				InputCount = KANJI_MAX_KANA - 1;
			}
		}
	}
	*pOutput = _T('\0');
}

void MergeDictionaryData(KANJI_DICTIONARY* pBuf, KANJI_DICTIONARY* pData, DWORD Count)
{
	KANJI_DICTIONARY* p;
	KANJI_DICTIONARY* e;
	KANJI_DICTIONARY* p1;
	KANJI_DICTIONARY* p2;
	KANJI_DICTIONARY* e1;
	KANJI_DICTIONARY* e2;
	if(Count > 2)
	{
		p = pBuf;
		e = pBuf + Count;
		p1 = pData;
		p2 = pData + Count / 2;
		e1 = p2;
		e2 = pData + Count;
		MergeDictionaryData(pBuf, p1, Count / 2);
		MergeDictionaryData(pBuf, p2, Count - Count / 2);
		while(p < e)
		{
			if(p1 < e1)
			{
				if(p2 < e2)
				{
					if(_tcscmp(p1->Kana, p2->Kana) > 0)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else if(p2 < e2)
			{
				if(p1 < e1)
				{
					if(_tcscmp(p1->Kana, p2->Kana) > 0)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p2;
					p2++;
				}
			}
			p++;
		}
		memcpy(pData, pBuf, sizeof(KANJI_DICTIONARY) * Count);
	}
	else if(Count == 2)
	{
		if(_tcscmp(pData[0].Kana, pData[1].Kana) > 0)
		{
			*pBuf = pData[0];
			pData[0] = pData[1];
			pData[1] = *pBuf;
		}
	}
}

void SortDictionary(KANJI_DICTIONARY* pData, DWORD Count)
{
	KANJI_DICTIONARY* pBuf;
	KANJI_DICTIONARY* p;
	KANJI_DICTIONARY* e;
	KANJI_DICTIONARY* p1;
	KANJI_DICTIONARY* p2;
	KANJI_DICTIONARY* e1;
	KANJI_DICTIONARY* e2;
	pBuf = new KANJI_DICTIONARY[(Count + 1) / 2];
	if(!pBuf)
		return;
	MergeDictionaryData(pBuf, pData, (Count + 1) / 2);
	memcpy(pBuf, pData, sizeof(KANJI_DICTIONARY) * ((Count + 1) / 2));
	MergeDictionaryData(pData, pData + (Count + 1) / 2, Count / 2);
	p = pData;
	e = pData + Count;
	p1 = pBuf;
	p2 = pData + (Count + 1) / 2;
	e1 = pBuf + (Count + 1) / 2;
	e2 = pData + Count;
	while(p < e)
	{
		if(p1 < e1)
		{
			if(p2 < e2)
			{
				if(_tcscmp(p1->Kana, p2->Kana) > 0)
				{
					*p = *p2;
					p2++;
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else
			{
				*p = *p1;
				p1++;
			}
		}
		else if(p2 < e2)
		{
			if(p1 < e1)
			{
				if(_tcscmp(p1->Kana, p2->Kana) > 0)
				{
					*p = *p2;
					p2++;
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else
			{
				*p = *p2;
				p2++;
			}
		}
		p++;
	}
	delete []pBuf;
}

void MergeCandidateData(KANJI_CANDIDATE* pBuf, KANJI_CANDIDATE* pData, DWORD Count)
{
	KANJI_CANDIDATE* p;
	KANJI_CANDIDATE* e;
	KANJI_CANDIDATE* p1;
	KANJI_CANDIDATE* p2;
	KANJI_CANDIDATE* e1;
	KANJI_CANDIDATE* e2;
	if(Count > 2)
	{
		p = pBuf;
		e = pBuf + Count;
		p1 = pData;
		p2 = pData + Count / 2;
		e1 = p2;
		e2 = pData + Count;
		MergeCandidateData(pBuf, p1, Count / 2);
		MergeCandidateData(pBuf, p2, Count - Count / 2);
		while(p < e)
		{
			if(p1 < e1)
			{
				if(p2 < e2)
				{
					if(p1->Point < p2->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else if(p2 < e2)
			{
				if(p1 < e1)
				{
					if(p1->Point < p2->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p2;
					p2++;
				}
			}
			p++;
		}
		memcpy(pData, pBuf, sizeof(KANJI_CANDIDATE) * Count);
	}
	else if(Count == 2)
	{
		if(pData[0].Point < pData[1].Point)
		{
			*pBuf = pData[0];
			pData[0] = pData[1];
			pData[1] = *pBuf;
		}
	}
}

void SortCandidate(KANJI_CANDIDATE* pData, DWORD Count)
{
	KANJI_CANDIDATE* pBuf;
	pBuf = new KANJI_CANDIDATE[Count];
	if(!pBuf)
		return;
	MergeCandidateData(pBuf, pData, Count);
	delete []pBuf;
}

void MergeBunsetsuCandidateData(KANJI_BUNSETSU_CANDIDATE* pBuf, KANJI_BUNSETSU_CANDIDATE* pData, DWORD Count)
{
	KANJI_BUNSETSU_CANDIDATE* p;
	KANJI_BUNSETSU_CANDIDATE* e;
	KANJI_BUNSETSU_CANDIDATE* p1;
	KANJI_BUNSETSU_CANDIDATE* p2;
	KANJI_BUNSETSU_CANDIDATE* e1;
	KANJI_BUNSETSU_CANDIDATE* e2;
	if(Count > 2)
	{
		p = pBuf;
		e = pBuf + Count;
		p1 = pData;
		p2 = pData + Count / 2;
		e1 = p2;
		e2 = pData + Count;
		MergeBunsetsuCandidateData(pBuf, p1, Count / 2);
		MergeBunsetsuCandidateData(pBuf, p2, Count - Count / 2);
		while(p < e)
		{
			if(p1 < e1)
			{
				if(p2 < e2)
				{
					if(p1->Point < p2->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else if(p2 < e2)
			{
				if(p1 < e1)
				{
					if(p1->Point < p2->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p2;
					p2++;
				}
			}
			p++;
		}
		memcpy(pData, pBuf, sizeof(KANJI_BUNSETSU_CANDIDATE) * Count);
	}
	else if(Count == 2)
	{
		if(pData[0].Point < pData[1].Point)
		{
			*pBuf = pData[0];
			pData[0] = pData[1];
			pData[1] = *pBuf;
		}
	}
}

void SortBunsetsuCandidate(KANJI_BUNSETSU_CANDIDATE* pData, DWORD Count)
{
	KANJI_BUNSETSU_CANDIDATE* pBuf;
	pBuf = new KANJI_BUNSETSU_CANDIDATE[Count];
	if(!pBuf)
		return;
	MergeBunsetsuCandidateData(pBuf, pData, Count);
	delete []pBuf;
}

void MergeDictionaryDataPointerPoint(KANJI_DICTIONARY** ppBuf, KANJI_DICTIONARY** ppData, DWORD Count)
{
	KANJI_DICTIONARY** p;
	KANJI_DICTIONARY** e;
	KANJI_DICTIONARY** p1;
	KANJI_DICTIONARY** p2;
	KANJI_DICTIONARY** e1;
	KANJI_DICTIONARY** e2;
	if(Count > 2)
	{
		p = ppBuf;
		e = ppBuf + Count;
		p1 = ppData;
		p2 = ppData + Count / 2;
		e1 = p2;
		e2 = ppData + Count;
		MergeDictionaryDataPointerPoint(ppBuf, p1, Count / 2);
		MergeDictionaryDataPointerPoint(ppBuf, p2, Count - Count / 2);
		while(p < e)
		{
			if(p1 < e1)
			{
				if(p2 < e2)
				{
					if((*p1)->Point < (*p2)->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p1;
					p1++;
				}
			}
			else if(p2 < e2)
			{
				if(p1 < e1)
				{
					if((*p1)->Point < (*p2)->Point)
					{
						*p = *p2;
						p2++;
					}
					else
					{
						*p = *p1;
						p1++;
					}
				}
				else
				{
					*p = *p2;
					p2++;
				}
			}
			p++;
		}
		memcpy(ppData, ppBuf, sizeof(KANJI_DICTIONARY*) * Count);
	}
	else if(Count == 2)
	{
		if(ppData[0]->Point < ppData[1]->Point)
		{
			*ppBuf = ppData[0];
			ppData[0] = ppData[1];
			ppData[1] = *ppBuf;
		}
	}
}

DWORD EnumKanjiCandidate(KANJI_DICTIONARY* pData, DWORD dwData, KANJI_DICTIONARY** ppKanji, DWORD Offset, KANJI_CANDIDATE* pOutput)
{
	KANJI_DICTIONARY* pOld;
	DWORD Count;
	DWORD LastFound;
	DWORD MaxOffset;
	KANJI_DICTIONARY* pTemp;
	if(pOutput)
	{
		Count = 0;
		while(ppKanji[Count])
		{
			Count++;
		}
		MaxOffset = Count;
		pOld = ppKanji[Offset];
		Count = 0;
		LastFound = 0;
		while(pTemp = FindKanji(pData, dwData, pOld->Kana, _tcslen(pOld->Kana), &LastFound))
		{
			ppKanji[Offset] = pTemp;
			pOutput[Count].pData = pTemp;
			pOutput[Count].Point = GetSentenceRelationPoint(ppKanji, MaxOffset);
			Count++;
			LastFound++;
		}
		ppKanji[Offset] = pOld;
		SortCandidate(pOutput, Count);
	}
	else
	{
		pOld = ppKanji[Offset];
		Count = 0;
		LastFound = 0;
		while(FindKanji(pData, dwData, pOld->Kana, _tcslen(pOld->Kana), &LastFound))
		{
			Count++;
			LastFound++;
		}
	}
	return Count;
}

DWORD EnumBunsetsuCandidate(KANJI_DICTIONARY* pData, DWORD dwData, KANJI_BUNSETSU* pBunsetsu, DWORD Offset, KANJI_BUNSETSU_CANDIDATE* pOutput)
{
	KANJI_BUNSETSU Temp[64];
	KANJI_BUNSETSU Old;
	DWORD Count;
	DWORD LastFound;
	DWORD MaxOffset;
	KANJI_DICTIONARY* pTemp;
	DWORD i;
	DWORD j;
	if(pOutput)
	{
		Count = 0;
		while(pBunsetsu[Count].pKanji[0])
		{
			Count++;
		}
		MaxOffset = Count;
		Old = pBunsetsu[Offset];
		EnumBunsetsu(pData, dwData, pBunsetsu[Offset].Kana, (DWORD)_tcslen(pBunsetsu[Offset].Kana), (KANJI_BUNSETSU*)&Temp, 64, TRUE, g_Preference.PointThreshold2);
		Count = 0;
		if(Offset > KANJI_MAX_HIGHEST_BUNSETSU - 1)
			i = Offset - KANJI_MAX_HIGHEST_BUNSETSU + 1;
		else
			i = 0;
		if(Offset + KANJI_MAX_HIGHEST_BUNSETSU < MaxOffset)
			j = Offset + KANJI_MAX_HIGHEST_BUNSETSU - i;
		else
			j = MaxOffset - i;
		while(Temp[Count].pKanji[0])
		{
			pBunsetsu[Offset] = Temp[Count];
			pOutput[Count].Data = Temp[Count];
			if(i == 0)
			{
				if(i + j >= MaxOffset)
					pOutput[Count].Point = GetBunsetsuRelationPoint(&pBunsetsu[i], j, TRUE, TRUE);
				else
					pOutput[Count].Point = GetBunsetsuRelationPoint(&pBunsetsu[i], j, TRUE, FALSE);
			}
			else
			{
				if(i + j >= MaxOffset)
					pOutput[Count].Point = GetBunsetsuRelationPoint(&pBunsetsu[i], j, FALSE, TRUE);
				else
					pOutput[Count].Point = GetBunsetsuRelationPoint(&pBunsetsu[i], j, FALSE, FALSE);
			}
			Count++;
		}
		pBunsetsu[Offset] = Old;
		if(Count < 64)
		{
			EnumTempBunsetsu(pBunsetsu[Offset].Kana, &Temp[Count], 64 - Count);
			while(Temp[Count].pKanji[0])
			{
				pOutput[Count].Data = Temp[Count];
				pOutput[Count].Point = LONG_MIN;
				Count++;
			}
		}
		SortBunsetsuCandidate(pOutput, Count);
	}
	else
	{
		EnumBunsetsu(pData, dwData, pBunsetsu[Offset].Kana, (DWORD)_tcslen(pBunsetsu[Offset].Kana), (KANJI_BUNSETSU*)&Temp, 64, TRUE, g_Preference.PointThreshold2);
		Count = 0;
		while(Temp[Count].pKanji[0])
		{
			Count++;
		}
	}
	return Count;
}

DWORD EnumBunsetsuComplement(KANJI_DICTIONARY* pData, DWORD dwData, TCHAR* pString, KANJI_BUNSETSU_CANDIDATE* pOutput)
{
	KANJI_DICTIONARY* pTemp[2][64];
	DWORD Count;
	DWORD i;
	Count = 0;
	i = FindKanjiHead(pData, dwData, pString, _tcslen(pString));
	while(i < dwData)
	{
		if(memcmp(pString, &pData[i].Kana, sizeof(TCHAR) * _tcslen(pString)) == 0)
		{
			pTemp[0][Count] = &pData[i];
			i++;
			Count++;
			if(Count >= 64)
				break;
		}
		else
			break;
	}
	MergeDictionaryDataPointerPoint((KANJI_DICTIONARY**)&pTemp[1], (KANJI_DICTIONARY**)&pTemp[0], Count);
	for(i = 0; i < Count; i++)
	{
		pOutput[i].Data.pKanji[0] = pTemp[0][i];
		pOutput[i].Data.pKanji[1] = NULL;
	}
	return Count;
}

BOOL SetDictionarySize(DWORD Count)
{
	KANJI_DICTIONARY* pTemp;
	pTemp = new KANJI_DICTIONARY[Count];
	if(!pTemp)
		return FALSE;
	if(g_pDictionary)
	{
		if(Count > g_dwDictionary)
		{
			memcpy(pTemp, g_pDictionary, sizeof(KANJI_DICTIONARY) * g_dwDictionary);
			ZeroMemory(pTemp + g_dwDictionary, sizeof(KANJI_DICTIONARY) * (Count - g_dwDictionary));
		}
		else
		{
			memcpy(pTemp, g_pDictionary, sizeof(KANJI_DICTIONARY) * Count);
			g_dwDictionary = Count;
		}
		delete []g_pDictionary;
		g_pDictionary = pTemp;
		g_dwMaxDictionary = Count;
	}
	else
	{
		ZeroMemory(pTemp, sizeof(KANJI_DICTIONARY) * Count);
		g_pDictionary = pTemp;
		g_dwDictionary = 0;
		g_dwMaxDictionary = Count;
	}
	return TRUE;
}

void SetDictionaryDataTrim(KANJI_DICTIONARY* pData, DWORD Count)
{
	DWORD i;
	for(i = 0; i < Count; i++)
	{
		pData[i].Kana[0] = KANJI_INVALID_CHAR;
		pData[i].Kana[1] = _T('\0');
	}
}

void SetDictionaryDataToTop(KANJI_DICTIONARY* pData, DWORD Count)
{
	KANJI_DICTIONARY Temp[KANJI_MAX_WORD];
	KANJI_DICTIONARY* p;
	memcpy(&Temp, pData, sizeof(KANJI_DICTIONARY) * Count);
	SetDictionaryDataTrim(pData, Count);
	p = g_pDictionary + g_dwDictionary - 1;
	while(p >= g_pDictionary)
	{
		p[Count] = p[0];
		p--;
	}
	memcpy(g_pDictionary, &Temp, sizeof(KANJI_DICTIONARY) * Count);
	g_dwDictionary += Count;
}

void SetDictionaryDataToKanaTop(KANJI_DICTIONARY** ppData, DWORD Count)
{
	DWORD i;
	DWORD j;
	KANJI_DICTIONARY Temp;
	KANJI_DICTIONARY* pTemp;
	KANJI_DICTIONARY* p;
	for(i = 0; i < Count; i++)
	{
		j = 0;
		pTemp = FindKanji(g_pDictionary, g_dwDictionary, ppData[i]->Kana, (DWORD)_tcslen(ppData[i]->Kana), &j);
		Temp = *ppData[i];
		p = ppData[i] - 1;
		while(p >= pTemp)
		{
			for(j = i + 1; j < Count; j++)
			{
				if(p == ppData[j])
					ppData[j]++;
			}
			p[1] = p[0];
			p--;
		}
		for(j = i + 1; j < Count; j++)
		{
			if(ppData[i] == ppData[j])
				ppData[j] = pTemp;
		}
		*pTemp = Temp;
	}
}

void TrimDictionaryData()
{
	while(g_dwDictionary > 0)
	{
		if(g_pDictionary[g_dwDictionary - 1].Kana[0] != KANJI_INVALID_CHAR)
			break;
		g_dwDictionary--;
	}
}

void SetDictionaryData(DWORD Type, DWORD PrevType, DWORD NextType, LONG Point, LPCTSTR Kana, LPCTSTR Kanji, LPCTSTR Relation)
{
	g_pDictionary[g_dwDictionary].Type = Type;
	g_pDictionary[g_dwDictionary].PrevType = PrevType;
	g_pDictionary[g_dwDictionary].NextType = NextType;
	g_pDictionary[g_dwDictionary].Point = Point;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kanji);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, Relation);
	g_dwDictionary++;
}

void SetDictionaryData(DWORD Type, DWORD PrevType, DWORD NextType, LPCTSTR Kana, LPCTSTR Kanji, LPCTSTR Relation)
{
	g_pDictionary[g_dwDictionary].Type = Type;
	g_pDictionary[g_dwDictionary].PrevType = PrevType;
	g_pDictionary[g_dwDictionary].NextType = NextType;
	g_pDictionary[g_dwDictionary].Point = 0;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kanji);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, Relation);
	g_dwDictionary++;
}

void SetDictionaryData(DWORD Type, DWORD NextType, LPCTSTR Kana, LPCTSTR Kanji, LPCTSTR Relation)
{
	g_pDictionary[g_dwDictionary].Type = Type;
	g_pDictionary[g_dwDictionary].PrevType = KANJI_PREV_ALL;
	g_pDictionary[g_dwDictionary].NextType = NextType;
	g_pDictionary[g_dwDictionary].Point = 0;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kanji);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, Relation);
	g_dwDictionary++;
}

void SetDictionaryData(DWORD Type, LPCTSTR Kana, LPCTSTR Kanji, LPCTSTR Relation)
{
	g_pDictionary[g_dwDictionary].Type = Type;
	g_pDictionary[g_dwDictionary].PrevType = KANJI_PREV_ALL;
	g_pDictionary[g_dwDictionary].NextType = KANJI_NEXT_ALL;
	g_pDictionary[g_dwDictionary].Point = 0;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kanji);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, Relation);
	g_dwDictionary++;
}

void SetDictionaryDummyData(DWORD Type, DWORD NextType, LPCTSTR Kana, LPCTSTR Kanji)
{
	g_pDictionary[g_dwDictionary].Type = Type | KANJI_TYPE_NO_RELATION;
	g_pDictionary[g_dwDictionary].PrevType = KANJI_PREV_ALL;
	g_pDictionary[g_dwDictionary].NextType = NextType;
	g_pDictionary[g_dwDictionary].Point = KANJI_POINT_NOT_FOUND;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kanji);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, _T(""));
	g_dwDictionary++;
}

void SetDictionaryDummyData(DWORD Type, DWORD NextType, LPCTSTR Kana)
{
	g_pDictionary[g_dwDictionary].Type = Type | KANJI_TYPE_NO_RELATION;
	g_pDictionary[g_dwDictionary].PrevType = KANJI_PREV_ALL;
	g_pDictionary[g_dwDictionary].NextType = NextType;
	g_pDictionary[g_dwDictionary].Point = KANJI_POINT_NOT_FOUND;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, _T(""));
	g_dwDictionary++;
}

void SetDictionaryDummyData(DWORD Type, LPCTSTR Kana)
{
	g_pDictionary[g_dwDictionary].Type = Type | KANJI_TYPE_NO_RELATION;
	g_pDictionary[g_dwDictionary].PrevType = KANJI_PREV_ALL;
	g_pDictionary[g_dwDictionary].NextType = KANJI_NEXT_ALL;
	g_pDictionary[g_dwDictionary].Point = KANJI_POINT_NOT_FOUND;
	_tcscpy(g_pDictionary[g_dwDictionary].Kana, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Kanji, Kana);
	_tcscpy(g_pDictionary[g_dwDictionary].Relation, _T(""));
	g_dwDictionary++;
}

BOOL SetInputDictionarySize(DWORD Count)
{
	if(g_pInputDictionary)
	{
		delete []g_pInputDictionary;
		g_pInputDictionary = NULL;
		g_dwInputDictionary = 0;
		g_dwMaxInputDictionary = 0;
	}
	g_pInputDictionary = new KANJI_DICTIONARY[Count];
	if(!g_pInputDictionary)
		return FALSE;
	ZeroMemory(g_pInputDictionary, sizeof(KANJI_DICTIONARY) * Count);
	g_dwInputDictionary = 0;
	g_dwMaxInputDictionary = Count;
	return TRUE;
}

void SetInputDictionaryData(LPCTSTR Input, LPCTSTR Kana)
{
	g_pInputDictionary[g_dwInputDictionary].Type = 0;
	g_pInputDictionary[g_dwInputDictionary].PrevType = 0;
	g_pInputDictionary[g_dwInputDictionary].NextType = 0;
	g_pInputDictionary[g_dwInputDictionary].Point = 0;
	_tcscpy(g_pInputDictionary[g_dwInputDictionary].Kana, Input);
	_tcscpy(g_pInputDictionary[g_dwInputDictionary].Kanji, Kana);
	_tcscpy(g_pInputDictionary[g_dwInputDictionary].Relation, _T(""));
	g_dwInputDictionary++;
}

void GetKanjiTypeString(KANJI_DICTIONARY* pKanji, TCHAR* pOut)
{
	if(pKanji->Type == KANJI_TYPE_DEFAULT && pKanji->PrevType == KANJI_PREV_DEFAULT && pKanji->NextType == KANJI_NEXT_DEFAULT)
	{
		if(pKanji >= g_pDictionary && pKanji < g_pDictionary + g_dwDictionary)
			_tcscpy(pOut, _T("wK"));
		else
			_tcscpy(pOut, _T("wK"));
	}
	else if(pKanji->Type & KANJI_TYPE_KUTOUTEN)
		_tcscpy(pOut, _T("Ǔ_"));
	else if(pKanji->Type & KANJI_TYPE_DOUSHI)
		_tcscpy(pOut, _T(""));
	else if(pKanji->Type & KANJI_TYPE_KEIYOUSHI)
		_tcscpy(pOut, _T("`e"));
	else if(pKanji->Type & KANJI_TYPE_MEISHI)
	{
		if(pKanji->Type & (KANJI_TYPE_JINMEI ^ KANJI_TYPE_KOYUUMEISHI))
			_tcscpy(pOut, _T("lEgD"));
		else if(pKanji->Type & (KANJI_TYPE_KOYUUMEISHI ^ KANJI_TYPE_MEISHI))
			_tcscpy(pOut, _T("ŗL"));
		else if(pKanji->Type & (KANJI_TYPE_KEIYOUMEISHI ^ KANJI_TYPE_MEISHI))
			_tcscpy(pOut, _T("`e"));
		else
		{
			if(pKanji->NextType == KANJI_NEXT_SAHENMEISHI)
				_tcscpy(pOut, _T("Tϖ"));
			else if(pKanji->NextType == KANJI_NEXT_ZAHENMEISHI)
				_tcscpy(pOut, _T("Uϖ"));
			else if(pKanji->NextType == KANJI_NEXT_SAHENDOUSHI)
				_tcscpy(pOut, _T("Tϓ"));
			else if(pKanji->NextType == KANJI_NEXT_ZAHENDOUSHI)
				_tcscpy(pOut, _T("Uϓ"));
			else
				_tcscpy(pOut, _T(""));
		}
	}
	else if(pKanji->Type & KANJI_TYPE_FUKUSHI)
		_tcscpy(pOut, _T(""));
	else if(pKanji->Type & KANJI_TYPE_SUUSHI)
		_tcscpy(pOut, _T(""));
	else if(pKanji->Type & KANJI_TYPE_BUNSETSU)
		_tcscpy(pOut, _T("P"));
	else
		_tcscpy(pOut, _T(""));
}

void GetBunsetsuTypeString(KANJI_BUNSETSU* pBunsetsu, TCHAR* pOut)
{
	DWORD i;
	i = 0;
	while(pBunsetsu->pKanji[i])
	{
		if((pBunsetsu->pKanji[i]->Type & KANJI_TYPE_JIRITSUGO) && !(pBunsetsu->pKanji[i]->Type & KANJI_TYPE_NO_COUNT))
		{
			GetKanjiTypeString(pBunsetsu->pKanji[i], pOut);
			return;
		}
		i++;
	}
	_tcscpy(pOut, _T(""));
}

