// jpiconv.cpp : R\[ AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "kanji.h"


class CFile : public CFileAlternative
{
public:
	DWORD m_dwSize;
	BYTE* m_pBuf;
	DWORD m_dwPointer;
	CFile()
	{
		CFileAlternative::CFileAlternative();
		m_dwSize = 0;
		m_pBuf = NULL;
		m_dwPointer = 0;
	}
	~CFile()
	{
		if(m_hFile != INVALID_HANDLE_VALUE && m_bCloseOnDelete)
			Close();
		if(m_pBuf)
			delete []m_pBuf;
	}
	BOOL Open(LPCTSTR lpszFileName, UINT nOpenFlags, void* pError)
	{
		Close();
		if(m_pBuf)
			delete []m_pBuf;
		m_dwSize = 65536;
		m_pBuf = new BYTE[m_dwSize];
		m_dwPointer = 0;
		return CFileAlternative::Open(lpszFileName, nOpenFlags, pError);
	}
    void Write(const void* lpBuf, UINT nCount)
	{
		DWORD dw;
		BYTE* pBuf;
		DWORD i;
		DWORD j;
		if(m_pBuf)
		{
			pBuf = (BYTE*)lpBuf;
			i = nCount;
			while(i > 0)
			{
				j = min(m_dwSize - m_dwPointer, i);
				memcpy(m_pBuf + m_dwPointer, pBuf, j);
				pBuf += j;
				i -= j;
				m_dwPointer += j;
				if(m_dwPointer >= m_dwSize)
				{
					WriteFile(m_hFile, m_pBuf, m_dwPointer, &dw, NULL);
					m_dwPointer = 0;
				}
			}
		}
		else
			WriteFile(m_hFile, lpBuf, nCount, &dw, NULL);
	}
	void Flush()
	{
		DWORD dw;
		if(m_pBuf)
			WriteFile(m_hFile, m_pBuf, m_dwPointer, &dw, NULL);
		m_dwPointer = 0;
		CFileAlternative::Flush();
	}
	void Close()
	{
		Flush();
		m_dwSize = 0;
		if(m_pBuf)
			delete []m_pBuf;
		m_pBuf = NULL;
		m_dwPointer = 0;
		CFileAlternative::Close();
	}
};

void PrintText(TCHAR** ppOut, LPCTSTR Text)
{
	_tcscpy(*ppOut, Text);
	while(**ppOut != _T('\0'))
	{
		(*ppOut)++;
	}
}

void ScanText(TCHAR** ppIn, TCHAR* Text)
{
	while(**ppIn != _T('\0') && **ppIn != _T('\r') && **ppIn != _T('\n'))
	{
		*Text = **ppIn;
		(*ppIn)++;
		Text++;
	}
	if(**ppIn == _T('\r'))
		(*ppIn)++;
	if(**ppIn == _T('\n'))
		(*ppIn)++;
	*Text = _T('\0');
}

BOOL SetLine(TCHAR* pOut, KANJI_DICTIONARY* pData)
{
	TCHAR* p;
	TCHAR Temp[16];
	p = pData->Kana;
	while(*p != _T('\0'))
	{
		switch(*p)
		{
		case _T('\\'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('\\');
			pOut++;
			p++;
			break;
		case _T('\t'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('t');
			pOut++;
			p++;
			break;
		default:
			*pOut = *p;
			pOut++;
			p++;
			break;
		}
	}
	*pOut = _T('\t');
	pOut++;
	p = pData->Kanji;
	while(*p != _T('\0'))
	{
		switch(*p)
		{
		case _T('\\'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('\\');
			pOut++;
			p++;
			break;
		case _T('\t'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('t');
			pOut++;
			p++;
			break;
		default:
			*pOut = *p;
			pOut++;
			p++;
			break;
		}
	}
	*pOut = _T('\t');
	pOut++;
	_stprintf(pOut, _T("%08x"), pData->Type);
	pOut += 8;
	*pOut = _T('\t');
	pOut++;
	_stprintf(pOut, _T("%08x"), pData->PrevType);
	pOut += 8;
	*pOut = _T('\t');
	pOut++;
	_stprintf(pOut, _T("%08x"), pData->NextType);
	pOut += 8;
	*pOut = _T('\t');
	pOut++;
	_stprintf(Temp, _T("%d"), pData->Point);
	PrintText(&pOut, Temp);
	*pOut = _T('\t');
	pOut++;
	p = pData->Relation;
	while(*p != _T('\0'))
	{
		switch(*p)
		{
		case _T('\\'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('\\');
			pOut++;
			p++;
			break;
		case _T('\t'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('t');
			pOut++;
			p++;
			break;
		case _T('\n'):
			*pOut = _T('\\');
			pOut++;
			*pOut = _T('n');
			pOut++;
			p++;
			break;
		default:
			*pOut = *p;
			pOut++;
			p++;
			break;
		}
	}
	*pOut = _T('\r');
	pOut++;
	*pOut = _T('\n');
	pOut++;
	*pOut = _T('\0');
	return TRUE;
}

BOOL GetLine(KANJI_DICTIONARY* pOut, TCHAR* pData)
{
	TCHAR* p;
	TCHAR* pEnd;
	p = pOut->Kana;
	pEnd = p + KANJI_MAX_KANA - 1;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		if(p >= pEnd)
			return FALSE;
		switch(*pData)
		{
		case _T('\\'):
			pData++;
			switch(*pData)
			{
			case _T('\\'):
				*p = _T('\\');
				pData++;
				p++;
				break;
			case _T('t'):
				*p = _T('\t');
				pData++;
				p++;
				break;
			}
			break;
		default:
			*p = *pData;
			pData++;
			p++;
			break;
		}
	}
	*p = _T('\0');
	pData++;
	p = pOut->Kanji;
	pEnd = p + KANJI_MAX_KANJI - 1;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		if(p >= pEnd)
			return FALSE;
		switch(*pData)
		{
		case _T('\\'):
			pData++;
			switch(*pData)
			{
			case _T('\\'):
				*p = _T('\\');
				pData++;
				p++;
				break;
			case _T('t'):
				*p = _T('\t');
				pData++;
				p++;
				break;
			}
			break;
		default:
			*p = *pData;
			pData++;
			p++;
			break;
		}
	}
	*p = _T('\0');
	pData++;
	pOut->Type = _tcstoul(pData, &p, 16);
	pData = p;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		pData++;
	}
	pData++;
	pOut->PrevType = _tcstoul(pData, &p, 16);
	pData = p;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		pData++;
	}
	pData++;
	pOut->NextType = _tcstoul(pData, &p, 16);
	pData = p;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		pData++;
	}
	pData++;
	pOut->Point = _tcstol(pData, &p, 0);
	pData = p;
	while(*pData != _T('\t'))
	{
		if(*pData == _T('\0'))
			return FALSE;
		pData++;
	}
	pData++;
	p = pOut->Relation;
	pEnd = p + KANJI_MAX_RELATION - 1;
	while(*pData != _T('\0'))
	{
		if(*pData == _T('\t'))
			return FALSE;
		if(p >= pEnd)
			return FALSE;
		switch(*pData)
		{
		case _T('\\'):
			pData++;
			switch(*pData)
			{
			case _T('\\'):
				*p = _T('\\');
				pData++;
				p++;
				break;
			case _T('t'):
				*p = _T('\t');
				pData++;
				p++;
				break;
			case _T('n'):
				*p = _T('\n');
				pData++;
				p++;
				break;
			}
			break;
		default:
			*p = *pData;
			pData++;
			p++;
			break;
		}
	}
	*p = _T('\0');
	return TRUE;
}

BOOL DictionaryToText(LPCTSTR FileIn, LPCTSTR FileOut)
{
	CFileAlternative File;
	KANJI_DICTIONARY_HEADER Header;
	KANJI_DICTIONARY* pDictionary;
	DWORD dwDictionary;
	TCHAR* pBuf;
	TCHAR* pCur;
	TCHAR Temp[256];
	DWORD i;
	if(!File.Open(FileIn, CFile::modeRead | CFile::shareDenyWrite, NULL))
	{
		_tprintf(_T("t@CG[܂B\n"));
		return FALSE;
	}
	if(File.Read(&Header, sizeof(KANJI_DICTIONARY_HEADER)) != sizeof(KANJI_DICTIONARY_HEADER))
	{
		_tprintf(_T("t@CG[܂B\n"));
		File.Close();
		return FALSE;
	}
	if(memcmp(&Header.Magic, "JIDF", 4) != 0)
	{
		_tprintf(_T("sȃtH[}bgłB\n"));
		File.Close();
		return FALSE;
	}
	if(Header.Version > 0x00010000)
	{
		_tprintf(_T("sȃtH[}bgłB\n"));
		File.Close();
		return FALSE;
	}
	pDictionary = new KANJI_DICTIONARY[Header.Count];
	if(!pDictionary)
	{
		_tprintf(_T("G[܂B\n"));
		File.Close();
		return FALSE;
	}
	ZeroMemory(pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count);
	dwDictionary = Header.Count;
	if(File.Read(pDictionary, sizeof(KANJI_DICTIONARY) * Header.Count) != sizeof(KANJI_DICTIONARY) * Header.Count)
	{
		_tprintf(_T("t@CG[܂B\n"));
		File.Close();
		delete []pDictionary;
		return FALSE;
	}
	File.Close();
	pBuf = new TCHAR[dwDictionary * 256 + 512];
	if(!pBuf)
	{
		_tprintf(_T("G[܂B\n"));
		delete []pDictionary;
		return FALSE;
	}
	pCur = pBuf;
	*pCur = 0xfeff;
	pCur++;
	_stprintf(Temp, _T("%u.%u"), Header.Version >> 16, Header.Version & 0x0000ffff);
	PrintText(&pCur, Temp);
	PrintText(&pCur, _T("\r\n"));
	_stprintf(Temp, _T("%u"), Header.Count);
	PrintText(&pCur, Temp);
	PrintText(&pCur, _T("\r\n"));
	PrintText(&pCur, Header.Description);
	PrintText(&pCur, _T("\r\n"));
	PrintText(&pCur, Header.Copyright);
	PrintText(&pCur, _T("\r\n"));
	for(i = 0; i < dwDictionary; i++)
	{
		if(!SetLine(Temp, &pDictionary[i]))
		{
			_tprintf(_T("sȃtH[}bgłB\n"));
			delete []pDictionary;
			delete []pBuf;
			return FALSE;
		}
		PrintText(&pCur, Temp);
	}
	if(!File.Open(FileOut, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite, NULL))
	{
		_tprintf(_T("t@CG[܂B\n"));
		delete []pDictionary;
		delete []pBuf;
		return FALSE;
	}
	File.Write(pBuf, (DWORD)(DWORD_PTR)pCur - (DWORD)(DWORD_PTR)pBuf);
	File.Close();
	delete []pDictionary;
	delete []pBuf;
	return TRUE;
}

BOOL TextToDictionary(LPCTSTR FileIn, LPCTSTR FileOut)
{
	CFileAlternative File;
	KANJI_DICTIONARY_HEADER Header;
	KANJI_DICTIONARY* pDictionary;
	DWORD dwDictionary;
	TCHAR* pBuf;
	TCHAR* pCur;
	TCHAR Temp[256];
	DWORD i;
	if(!File.Open(FileIn, CFile::modeRead | CFile::shareDenyWrite, NULL))
	{
		_tprintf(_T("t@CG[܂B\n"));
		return FALSE;
	}
	pBuf = new TCHAR[(DWORD)File.GetLength() / sizeof(TCHAR) + 1];
	if(!pBuf)
	{
		_tprintf(_T("G[܂B\n"));
		File.Close();
		return FALSE;
	}
	pBuf[(DWORD)File.GetLength() / sizeof(TCHAR)] = _T('\0');
	if(File.Read(pBuf, (UINT)File.GetLength()) != (UINT)File.GetLength())
	{
		_tprintf(_T("t@CG[܂B\n"));
		File.Close();
		delete []pBuf;
		return FALSE;
	}
	File.Close();
	pDictionary = new KANJI_DICTIONARY[1048576];
	if(!pDictionary)
	{
		_tprintf(_T("G[܂B\n"));
		delete []pBuf;
		return FALSE;
	}
	ZeroMemory(pDictionary, sizeof(KANJI_DICTIONARY) * 1048576);
	ZeroMemory(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	dwDictionary = 0;
	pCur = pBuf;
	if(*pCur != 0xfeff)
	{
		_tprintf(_T("sȃtH[}bgłB\n"));
		delete []pBuf;
		delete []pDictionary;
		return FALSE;
	}
	pCur++;
	memcpy(&Header.Magic, "JIDF", 4);
	ScanText(&pCur, Temp);
	_stscanf(Temp, _T("%u.%u"), &i, &Header.Version);
	Header.Version = (i << 16) | (Header.Version & 0x0000ffff);
	ScanText(&pCur, Temp);
	Header.Count = _tcstoul(Temp, NULL, 0);
	ScanText(&pCur, Header.Description);
	ScanText(&pCur, Header.Copyright);
	while(*pCur != _T('\0'))
	{
		if(dwDictionary == 1048576)
			_tprintf(_T("1048576ȏ͓o^ł܂B\n"));
		ScanText(&pCur, Temp);
		if(!GetLine(&pDictionary[dwDictionary], Temp))
		{
			_tprintf(_T("s%uŃG[܂B\n%s\n"), dwDictionary + 4, Temp);
			delete []pDictionary;
			delete []pBuf;
			return FALSE;
		}
		dwDictionary++;
	}
	if(!File.Open(FileOut, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite, NULL))
	{
		_tprintf(_T("t@CG[܂B\n"));
		delete []pDictionary;
		delete []pBuf;
		return FALSE;
	}
	File.Write(&Header, sizeof(KANJI_DICTIONARY_HEADER));
	File.Write(pDictionary, sizeof(KANJI_DICTIONARY) * dwDictionary);
	File.Close();
	delete []pDictionary;
	delete []pBuf;
	return TRUE;
}

int _tmain(int argc, _TCHAR* argv[])
{
	_tsetlocale(LC_ALL, _T(""));
	if(argc != 4)
	{
		_tprintf(_T("Japanese Input t@Cϊc[\n"));
		_tprintf(_T("\n"));
		_tprintf(_T("jpiconv -t dictionary text\n"));
		_tprintf(_T("t@CdictionaryeLXgt@Ctextɕϊ܂B\n"));
		_tprintf(_T("\n"));
		_tprintf(_T("jpiconv -d text dictionary\n"));
		_tprintf(_T("eLXgt@Ctextt@Cdictionaryɕϊ܂B\n"));
		_tprintf(_T("\n"));
		_tprintf(_T("eLXgt@C͉sR[h\\r\\nAUTF-16 LEABOMt̂̂gp\łB\n"));
		_tprintf(_T("\n"));
		return 0;
	}
	if(_tcsicmp(argv[1], _T("-t")) == 0)
	{
		DictionaryToText(argv[2], argv[3]);
	}
	if(_tcsicmp(argv[1], _T("-d")) == 0)
	{
		TextToDictionary(argv[2], argv[3]);
	}
	return 0;
}

